Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.api
Class Designer

    java.lang.Object
      jet.api.API
          jet.api.Designer

Direct Known Subclasses:
  MultipliedDesigner, MultiUserDesigner

    public class Designer

extends API

The Designer class allows an application to create and manipulate JReport ReportSets (.cls) and its children objects. By building a Designer instance in a Java program, users can edit a ReportSet by methods provided by `API`.
ReportSets are also called Page Reports in JReport manuals.

JReport ReportSet and its objects are stored in a tree structure. An instance of `Designer` can retrieve each object in the ReportSet by its handle. The handle of an object is named by its qualified and unique instance name.

A ReportSet is composed of one or more reports (also called tabs or sheets) that are designed for the same purpose, or related purposes. Report developers can design, maintain, run and schedule these reports together or separately. The reports in the same ReportSet can share the same parameters and DataSets which reduces the number of queries to the DBMS.

A dataset is the set of data built from the result of a query, and can optionally have filters applied to it. A dataset contains not only DBFields, but also all formulas, summaries, and parameters that use the DBFields. A dataset has a name, which by default is the name of the resource on which it is created. When you create a data component, you specify whether to create a new dataset for it or use an existing one.

JReport reports are usually composed of multiple components. Components in JReport can be classified as follows:

- Static components - labels, images, barcodes, tabulars, groups, sections, subreports, UDOs.
- Data components - reports, tables, crosstabs, charts, and banded objects
- Fields - DBFields, formula fields, summary fields, parameter fields often referred to as mapping names (as opposed to actual DBMS table and column names)
- Drawing objects - lines, arcs, boxes, ovals, round boxes supported only in banded objects
- Special fields - Print Date, Print Time, Fetch Date, Fetch Time, Record Number and many more.

A label is an object that contains a string. It is typically a brief description used to identify a field or other value nearby.

An image is a digital representation of a picture. JReport supports the following image formats: .bmp, .gif, .jpg, and .png.

A table is composed of rows and columns, and each contains several cells. Tables give you great control over how to present data, including placing fields, grouping them, and sorting them. With such a structure a table is a good way to show any two-dimensional dataset.

A crosstab summarizes data and presents the summaries in a compact row and column format.

A chart organizes and graphically presents data in a way that makes it easy for end users to see comparisons, trends, and patterns in data. It represents the report data in a visually straightforward form. A chart is based on the chart platform. On the platform, the chart paper, the legend, and labels make up the chart. You can create a chart that contains only simple DBFields, or a complicated chart that contains DBFields, groups, summaries, and even formulas. Normally, DBFields, summaries, and formulas in a report are represented in a chart using chart data markers, and groups are used to produce category names and data series names. DBFields can also be used as category names.

A banded object is a component that can present grouped data and detailed data. A banded object is composed of several banded panels(sections) with which you can easily organize data fields and other elements.

A tabular is a component designed to lay out other components. Unlike a table component, which is used to display a dataset, a tabular is a set of cells that can each display a data component.

A report that is inserted into another report is referred to as the subreport. Subreports are inserted and managed just like a component in a primary report, but a subreport itself is created and managed just like a primary report. You can specify relationships between the primary report and the subreport as well as have JReport pass values to the primary report or the subreport. A primary report can have more than one subreport. They can be in the same ReportSet as the primary report or can be in different ReportSets.

Formula fields are calculated from DBFields, other formulas, summaries, parameters and constants, so they can present information that DBFields cannot do.

A summary is a special kind of formula. A summary generates a count, average, sum, standard deviation or other aggregation of a set of data values. A summary may apply to a defined group of data or can be a dynamic summary able to summarize on any group.

A parameter in JReport is a variable whose value is determined at runtime. The runtime parameters help you dynamically control your report results when used as parameters in a query.

Drawing objects can only be inserted into banded objects. You can add arcs, ovals, boxes, round boxes and lines to your report.

Some components can be bound with a dataset or inherit data from the dataset of their parents. These components are table, chart, crosstab, and banded object, and they are also referred to as data containers or data components. Depending on the location of the libraries you either need a Designer API License Key or a Server Designer API License Key. If you are using Designer libraries you need report.jar and JREngine.jar (Designer API License Key) If you are using Server libraries you need JRSRMI.jar (Server Designer API License Key)

For detailed explanation about the object properties, refer to the help document Getting property information

The following is one example of the use of the `Designer` . The code:

>       Designer dr = null;
>             try
>             {
>                       String path = "C:\\JReport\\Designer\\Demo\\Reports\\TutorialReports";
>             String catName = "TutorialReports.cat";
>             DesignerUserInfo userInfo=new DesignerUserInfo("UID", "designer API license key");
>                       dr = new Designer(path, catName,userInfo);
>                       CatalogAPI cat = dr.getCatalogAPI();
>              ......
>             }
>             finally
>             {
>                     dr.exit();
>             }

>        // To create a new ReportSet (Page Report) with a banded object using the above Designer (dr)
>        // 1. Create ReportSet
>        reportset = dr.createReportSet(name);
>        // 2. Add Dataset
>        dataset = dr.addDataset(reportset, queryname, dsname, null, Designer.DATASET_TYPE_QUERY);
>        // 3. Create a report tab inside the ReportSet
>        report = dr.addReport(reportset, name);
>        // 4. Insert a PagePanel into the report tab
>        page = dr.insertPage(report);
>        // 5. Insert the data component you want to use such as a banded object
>        banded = dr.insertBandedObject(reportbody, true, true, true);
>        // 6. Bind the dataset to the reportbody and set inherit from parent for the banded object
>        dr.bindDataSet(reportbody, queryname);
>        dr.set(banded, "dataInherit", true);
>        // 7. Get handles so that you can start adding objects to the report
>        handles = dr.getHandles(banded, Designer.PAGE);
>           ......
>        // 8. Add groups to the banded object page
>        GroupInfo ginfo = new GroupInfo(dbfield,GroupInfo.DESCENDING);
>        group = dr.insertSectionGroup(handles[0], ginfo);
>           .....
>        // 9. Exit and save changes
>        dr.exit();

Field Summary
`static int` | `ARC` Shape object type.
`static int` | `AREA_ARRAY_2D` The chart type value.
`static int` | `AREA_ARRAY_3D` The chart type value.
`static int` | `AREA_PERCENT_2D` The chart type value.
`static int` | `AREA_PERCENT_3D` The chart type value.
`static int` | `AREA_STACK_2D` The chart type value.
`static int` | `AREA_STACK_3D` The chart type value.
`static int` | `AREACHART` The chart type value.
`static int` | `BANDEDOBJECT` JReport BandedObject object type.
`static int` | `BANDEDOBJECT_FOOTER` BandedObjectFooter Section object type.
`static int` | `BANDEDOBJECT_HEADER` BandedObjectHeader Section object type.
`static int` | `BANDEDOBJECT_PAGEFOOTER` BandedObject PageFooter Section object type.
`static int` | `BANDEDOBJECT_PAGEHEADER` BandedObject PageHeader Section object type.
`static int` | `BAR_ARRAY_3D` The chart type value.
`static int` | `BAR_PERCENT_2D` The chart type value.
`static int` | `BAR_PERCENT_3D` The chart type value.
`static int` | `BAR_PERCENT_AREA_STACK_2D` The chart type value.
`static int` | `BAR_PERCENT_LINE_ARRAY_2D` The chart type value.
`static int` | `BAR_PERCENT_LINE_STACK_2D` The chart type value.
`static int` | `BAR_SIDEBYSIDE_2D` The chart type value.
`static int` | `BAR_SIDEBYSIDE_3D` The chart type value.
`static int` | `BAR_SIDEBYSIDE_AREA_STACK_2D` The chart type value.
`static int` | `BAR_SIDEBYSIDE_LINE_ARRAY_2D` The chart type value.
`static int` | `BAR_SIDEBYSIDE_LINE_STACK_2D` The chart type value.
`static int` | `BAR_STACK_2D` The chart type value.
`static int` | `BAR_STACK_3D` The chart type value.
`static int` | `BAR_STACK_AREA_STACK_2D` The chart type value.
`static int` | `BAR_STACK_LINE_ARRAY_2D` The chart type value.
`static int` | `BAR_STACK_LINE_STACK_2D` The chart type value.
`static int` | `BARCHART` The chart type value.
`static int` | `BARCODEFIELD` JReport BarCode object type.
`static int` | `BENCH_ARRAY_3D` The chart type value.
`static int` | `BENCH_PERCENT_2D` The chart type value.
`static int` | `BENCH_PERCENT_3D` The chart type value.
`static int` | `BENCH_SIDEBYSIDE_2D` The chart type value.
`static int` | `BENCH_SIDEBYSIDE_3D` The chart type value.
`static int` | `BENCH_STACK_2D` The chart type value.
`static int` | `BENCH_STACK_3D` The chart type value.
`static int` | `BENCHARRAYCHART` The chart type value.
`static int` | `BENCHCHART` The chart type value.
`static int` | `BOX` Shape object type.
`static int` | `BUBBLE_2D` The chart type value.
`static int` | `CENTERBOTTOM` The alignment type value.
`static int` | `CENTERCENTER` The alignment type value.
`static int` | `CENTERTOP` The alignment type value.
`static int` | `CHART2DCOORDINATEPAPER` Combinatorial 2D Chart CoordinatePaper object type.
`static int` | `CHARTCOORDINATEPAPER` Combinatorial Chart CoordinatePaper object type.
`static int` | `CHARTLABEL` Combinatorial Chart Label object type
`static int` | `CHARTLEGEND` Combinatorial Chart Legend object type.
`static int` | `CHARTPLATFORM` Combinatorial Chart Platform object type.
`static int` | `CODABAR` The Barcode type value.
`static int` | `CODE_128` The Barcode type value.
`static int` | `CODE_39` The Barcode type value.
`static int` | `COLUMN` Table Column object type.
`static int` | `COMPUTEDCOLUMN` ComputedColumn Field object type.
`static int` | `CROSSTAB` Combinatorial Crosstab object type.
`static int` | `CTAGGFIELD` Combinatorial Crosstab Aggregation Field object type.
`static int` | `CTAGGINFO` Combinatorial Crosstab AggregationInfo object type.
`static int` | `CTDBFIELD` Combinatorial Crosstab Field object type.
`static int` | `CTHDDBFIELD` Combinatorial Crosstab Header Field object type.
`static int` | `CTHDTEXTFIELD` Combinatorial Crosstab HeaderText Field object type.
`static int` | `DATAOBJECT` DataContainer object type.
`static int` | `DATASET` DataSet object type.
`static int` | `DATASET_TYPE_HDS` The Dataset type constant.
`static int` | `DATASET_TYPE_ONDEMAND` The Dataset type constant.
`static int` | `DATASET_TYPE_QUERY` The Dataset type constant.
`static int` | `DBFIELD` Database Field object type.
`static int` | `DETAIL` Detail Section object type.
`static int` | `DIRECTION_BACKSIDE` The type values.
`static int` | `DIRECTION_FORESIDE` The direction value.
`static int` | `EAN_13` The Barcode type value.
`static int` | `EAN_8` The Barcode type value.
`static int` | `FETCHDATE` JReport Special Field object type
`static int` | `FETCHTIME` JReport Special Field object type
`static int` | `FIELD_CATALOGPATH_ONDISK` JReport Special Field object types.
`static int` | `FIELD_CATALOGPATH_ONSERVER` JReport Special Field object types.
`static int` | `FIELD_REPORTPATH_ONDISK` JReport Special Field object types.
`static int` | `FIELD_REPORTPATH_ONSERVER` JReport Special Field object types.
`static int` | `FORMULA` Formula Field object type.
`static int` | `GAUGE_BALLS_2D` The chart type value.
`static int` | `GAUGE_BARS_2D` The chart type value.
`static int` | `GAUGE_DIALS_2D` The chart type value.
`static int` | `GROUP` Group object type.
`static int` | `GROUPFOOTER` GroupFooter Section object type.
`static int` | `GROUPHEADER` GroupHeader Section object type.
`static int` | `GROUPNAME` JReport Special Field object type
`static int` | `GROUPNUMBER` JReport Special Field object type
`static int` | `GROUPNUMBERS` JReport Special Field object type
`static int` | `IMAGE` Image object type.
`static int` | `JBROWSER` JReport UDO object type
`static int` | `JHYPERLINK` JReport UDO object type
`static int` | `JUSTIFYBOTTOM` The alignment type value.
`static int` | `JUSTIFYCENTER` The alignment type value.
`static int` | `JUSTIFYTOP` The alignment type value.
`static int` | `LABEL` Label Field object type.
`static int` | `LEFT` The moving direction value.
`static int` | `LEFT_UNDERSIDE_POINT` The resize direction value.
`static int` | `LEFT_UPSIDE_POINT` The resize direction value.
`static int` | `LEFTBOTTOM` The alignment type value.
`static int` | `LEFTCENTER` The alignment type value.
`static int` | `LEFTTOP` The alignment type value.
`static int` | `LINE` Shape object type.
`static int` | `LINE_ARRAY_2D` The chart type value.
`static int` | `LINE_ARRAY_3D` The chart type value.
`static int` | `LINE_ARRAY_LINE_ARRAY_2D` The chart type value.
`static int` | `LINE_PERCENT_2D` The chart type value.
`static int` | `LINE_STACK_2D` The chart type value.
`static int` | `LINECHART` The chart type value.
`static int` | `MEDIAFIELD` JReport MediaField object type.
`static int` | `MODIFIEDDATE` JReport Special Field object type
`static int` | `MODIFIEDTIME` JReport Special Field object type
`static int` | `MULTI_VALUE_BOX` Container object type.
`static int` | `NEWSTYLETABLE` Table object type.
`static int` | `OVAL` Shape object type.
`static int` | `PAGE` Page container object type.
`static int` | `PAGEBREAK` JReport PageBreak object type.
`static int` | `PAGEEND` JReport PageEnd object type.
`static int` | `PAGEFOOTER` PageFooter Section object type.
`static int` | `PAGEHEADER` PageHeader Section object type.
`static int` | `PAGENOFM` Special Field object types.
`static int` | `PAGENUMBER` JReport Special Field object type
`static int` | `PAGENUMBERS` JReport Special Field object type
`static int` | `PAGESTART` JReport PageStart object type.
`static int` | `PARAGRAPH` Container object type.
`static int` | `PARALLELDETAIL` Parallel Detail Section object type.
`static int` | `PARAMETER` Parameter Field object type.
`static int` | `PIE_SIDEBYSIDE_2D` The chart type value.
`static int` | `PIE_SIDEBYSIDE_3D` The chart type value.
`static int` | `PIECHART` The chart type value.
`static int` | `PRINTDATE` JReport Special Field object type
`static int` | `PRINTTIME` JReport Special Field object type
`static int` | `RADAR_2D` The chart type value.
`static int` | `RECORDNUMBER` JReport Special Field object type
`static int` | `RENDER_BARCODE` The field render type constant.
`static int` | `RENDER_BUTTON` The field render type constant.
`static int` | `RENDER_CHECKBOX` The field render type constant.
`static int` | `RENDER_DROPDOWNLIST` The field render type constant.
`static int` | `RENDER_IMAGE` The field render type constant.
`static int` | `RENDER_IMAGEBUTTON` The field render type constant.
`static int` | `RENDER_LIST` The field render type constant.
`static int` | `RENDER_RADIOBTN` The field render type constant.
`static int` | `RENDER_RANK` The field render type constant.
`static int` | `RENDER_RESETBUTTON` The field render type constant.
`static int` | `RENDER_SUBMITBUTTON` The field render type constant.
`static int` | `RENDER_TEXT` The field render type constant.
`static int` | `RENDER_TEXTAREA` The field render type constant.
`static int` | `RENDER_TEXTFIELD` The field render type constant.
`static int` | `REPORT` Report object type.
`static int` | `REPORTBODY` ReportBody object type.
`static int` | `REPORTFOOTER` ReportFooter Section object type.
`static int` | `REPORTHEADER` ReportHeader Section object type.
`static int` | `REPORTSET` ReportSet object type.
`static int` | `REPORTSHEET` Report object type.
`static int` | `RIGHT` The moving direction value.
`static int` | `RIGHT_UNDERSIDE_POINT` The resize direction value.
`static int` | `RIGHT_UPSIDE_POINT` The resize direction value.
`static int` | `RIGHTBOTTOM` The alignment type value.
`static int` | `RIGHTCENTER` The alignment type value.
`static int` | `RIGHTTOP` The alignment type value.
`static int` | `ROUNDBOX` Shape object type.
`static int` | `RPTDATASOURCE` Report Datasource object type
`static int` | `SCATTER_POINTS_2D` The chart type value.
`static int` | `SCATTER_SMOOTH_LINES_2D` The chart type value.
`static int` | `SCATTER_STRAIGHT_LINES_2D` The chart type value.
`static int` | `SHAPE` Shape object type.
`static int` | `SIDEBYSIDEBARCHART` The chart type value.
`static int` | `SQLSTATMENT` JReport Special Field object type
`static int` | `STACKEDBARCHART` The chart type value.
`static int` | `STACKEDBENCH` The chart type value.
`static int` | `STOCK_HIGH_LOW_2D` The chart type value.
`static int` | `STOCK_HIGH_LOW_CLOSE_2D` The chart type value.
`static int` | `STOCK_OPEN_HIGH_LOW_CLOSE_2D` The chart type value.
`static int` | `SUBLINK` SubreportLink object type.
`static int` | `SUBPARAMLINK` Subreport ParamterLink object type.
`static int` | `SUBREPORT` Subreport object type.
`static int` | `SUBRETVALUE` Subreport ReturnValue object type .
`static int` | `SUMMARY` Summary Field object type.
`static int` | `SURFACE_3D` The chart type value.
`static int` | `TABLE` Deprecated.
`static int` | `TABLE_COMMONCOLUMN` Table COMMON column object type.
`static int` | `TABLE_DETAILCOLUMN` Table DETAIL column object type.
`static int` | `TABLE_DETAILSECTION` TableDetail Section object type.
`static int` | `TABLE_FOOTERSECTION` TableFooter Section object type.
`static int` | `TABLE_GROUP_FOOTERSECTION` Table GroupFooter section object type.
`static int` | `TABLE_GROUP_HEADERSECTION` Table GroupHeader section object type.
`static int` | `TABLE_GROUPCOLUMN` Table GROUP column object type.
`static int` | `TABLE_HEADERSECTION` TableHeader Section object type.
`static int` | `TABLE_SUMMARYCOLUMN` Table SUMMARY column object type.
`static int` | `TABLECELL` Table cell object type.
`static int` | `TABULARCELL` JReport Tabula object type.
`static int` | `TEXT` JReport TextArea object type.
`static int` | `TEXTBOX` TextBox object type.
`static int` | `UDO` JReport UDO object type.
`static int` | `UPC_A` The Barcode type value.
`static int` | `UPC_E` The Barcode type value.
`static int` | `USERNAME` JReport Special Field object type
`static int` | `ZORDER_BACKWARD` The z-order type constant.
`static int` | `ZORDER_BOTTOM` The z-order type constant.
`static int` | `ZORDER_FORWARD` The z-order type constant.
`static int` | `ZORDER_TOP` The z-order type constant.

Fields inherited from class jet.api.API
`BOOLEAN, CAT, CENTIMETER, COLOR, DOUBLE, ENUM, FLOAT, INCH, INTEGER, LONG, PIXEL, REFERENCE, RPT, SELFRPT, STRING, TEXTRPT, UNKNOWN, XMLCAT, XMLRPT`

Constructor Summary
`Designer(java.lang.String path, java.lang.String name)` Deprecated. since version 6.1. Replaced by `Designer(String, String, DesignerUserInfo)`
`Designer(java.lang.String path, java.lang.String name, DesignerUserInfo user)` Constructor.
`Designer(java.lang.String path, java.lang.String name, java.lang.String suffix)` Deprecated. since version 6.1.
`Designer(java.lang.String path, java.lang.String name, java.lang.String suffix, DesignerUserInfo user)` Constructor.

Method Summary
`java.lang.String` | `addDataset(java.lang.String reportsetHandle, java.lang.String datasourceName, java.lang.String queryName, java.lang.String name, java.lang.String BVName, int datasetType)` Creates a dataset in the reportset.
`void` | `addDisplayName(java.lang.String report, DisplayNameInfo displayNameInfo)` Adds a Display Name into a report.
`boolean` | `addDisplayName(java.lang.String report, java.lang.String datasetHandle, DisplayNameInfo displayNameInfo)` Adds a DisplayName to a report.
`java.lang.String` | `addReport(java.lang.String reportsetHandle, java.lang.String name)` Adds a report to the reportset.
`boolean` | `appendTabularColumn(java.lang.String tabular)` Adds a tabular column after the last column of the tabular.
`boolean` | `appendTabularRow(java.lang.String tabular)` Adds a tabular row after the last row of the tabular.
`boolean` | `bindDataSet(java.lang.String handle, java.lang.String datasetName)` Binds a dataset to a data container object.
`boolean` | `canDeleted(java.lang.String handle)` Checks whether the instance can be deleted or not.
`boolean` | `canMergeTableCell(java.lang.String table, java.lang.String[] cellHandles)` Checks whether the cells can be merged or not.
`boolean` | `canMergeTabularCell(java.lang.String tabular, java.lang.String[] cellHandles)` Checks whether the cells can be merged or not.
`boolean` | `changeTabularCellHeight(java.lang.String tabular, java.lang.String cellHandle, double dispersion)` Modifies a tabular cell object's height.
`boolean` | `changeTabularCellWidth(java.lang.String tabular, java.lang.String cellHandle, double dispersion)` Modifies a tabular cell object's width.
`boolean` | `changeTabularHeight(java.lang.String tabular, double dispersion)` Modifies a tabular object's height.
`boolean` | `changeTabularWidth(java.lang.String tabular, double dispersion)` Modifies a tabular object's width.
`boolean` | `changeZOrder(java.lang.String objectHandle, int zorderType)` Sets z-order of cascading objects.
`boolean` | `close(java.lang.String handle)` Closes a report panel according to a report handle.
`boolean` | `closeReportSet()` Closes the current reportset and saves the changes.
`java.lang.String` | `create(java.lang.String name, java.lang.String query)` Deprecated. since version 8.0, replaced by `createReportSet(String)`.
`java.lang.String` | `create(java.lang.String name, java.lang.String sourceName, java.lang.String query)` Deprecated. since version 8.0, replaced by `createReportSet(String)`.
`java.lang.String` | `createReportSet(java.lang.String name)` Creates a new reportset with an instance name.
`boolean` | `delete(java.lang.String handle)` Deletes an object from its parent node.
`boolean` | `deleteBandedObject(java.lang.String bandedObject)` Deletes a Banded Object from a report
`boolean` | `deleteCrossTabAggregations(java.lang.String crossTab, int[] index)` Deletes aggregations from a crosstab.
`boolean` | `deleteCrossTabColumns(java.lang.String crossTab, int[] index)` Deletes crosstab columns.
`boolean` | `deleteCrossTabRows(java.lang.String crossTab, int[] index)` Deletes rows from a crosstab.
`boolean` | `deleteDetailPanel(java.lang.String detailSection)` Deletes a detail section from a report.
`boolean` | `deleteGroup(java.lang.String groupHandle, boolean removeAllChildren)` Deletes a group object from a report.
`boolean` | `deletePage(java.lang.String pageHandle)` Deletes a page panel object from a report.
`boolean` | `deletePageController(java.lang.String controllerHandle)` Deletes a page controller object from a report
`boolean` | `deleteReport(java.lang.String name)` Deprecated. since version 8.0, replaced by `deleteReportFile(String)`.
`boolean` | `deleteReport(java.lang.String rptsetHandle, java.lang.String name)` Deletes a report from the reportset.
`boolean` | `deleteReportFile(java.lang.String name)` Deletes a reportset file with a file name.
`boolean` | `deleteSectionFooterPanel(java.lang.String footerSection)` Deletes a footer section from a report
`boolean` | `deleteSectionHeaderPanel(java.lang.String headerSection)` Deletes a header section from a report.
`boolean` | `deleteTableColumns(java.lang.String table, int[] index)` Deletes columns from a new style table.
`boolean` | `deleteTabularColumn(java.lang.String tabular, java.lang.String cellHandle)` Deletes a tabular column from a tabular.
`boolean` | `deleteTabularRow(java.lang.String tabular, java.lang.String cellHandle)` Deletes a tabular row from a tabular.
`void` | `exit()` Exits from editing mode.
`void` | `exitAndSave()` Exits from editing mode.
`java.util.Vector` | `getAllDisplayNames(java.lang.String report)` Gets all DisplayName objects in a report.
`java.lang.String[]` | `getAllResourceNames(java.lang.String report)` Gets all resource names used in report.
`CatalogAPI` | `getCatalogAPI()` Gets a CatalogAPI instance with the specified catalog.
`java.lang.String` | `getCatalogName()` Gets the loaded catalog's name.
`java.lang.String[]` | `getChangedByFields(java.lang.String handle, java.lang.String propertyName)` Gets the fields that can be used to control the object's property values at runtime.
`ChartLabelInfo` | `getChartLabel(java.lang.String handle)` Gets the label information in the chart.
`java.lang.String` | `getControlField(java.lang.String handle, java.lang.String name)` Gets the field that controls the property value at runtime.
`java.lang.String[]` | `getControlFields(java.lang.String handle, java.lang.String name)` Gets the fields that can be used to control an object's property values at runtime.
`BLFilterInformation` | `getDatasetBLFilter(java.lang.String datasetHandle)` Gets a JReport businees logic filter from the specified dataset.
`java.lang.String[]` | `getDBFields(java.lang.String handle)` Gets the DBField mapping names from the query that is bound to the object
`DisplayNameInfo` | `getDisplayName(java.lang.String report, java.lang.String resourceName)` Gets the definition of DisplayName by field mapping name.
`java.lang.String[]` | `getFormats(java.lang.String handle)` Gets the default format list of the object.
`java.lang.String[]` | `getFormulae(java.lang.String handle)` Gets the formulae that can be used in the report.
`java.lang.String[]` | `getFormulas(java.lang.String report)` Gets all formula names used in a report.
`java.lang.String[]` | `getGeometries(java.lang.String handle)` Gets the handles of the geometry objects in a report.
`java.lang.String[]` | `getGeometries(java.lang.String handle, boolean visible)` Gets the handles of the geometry objects in a report.
`GroupInfo[]` | `getGroupInfo(java.lang.String handle)` Gets the group information of the report.
`java.util.Vector` | `getGroupNames(java.lang.String report)` Gets all groupby fields' mapping names of the groups in a report.
`java.lang.String[]` | `getGroups(java.lang.String handle)` Gets the handles of the groups in a report.
`int` | `getIndex(java.lang.String objHandle)` Gets the child index in its parent container.
`java.lang.String` | `getKey()` Gets the key of JReport Design API.
`float` | `getMinSectionHeight(java.lang.String handle)` Gets the minimum height value of the section.
`ObjectInfo` | `getObjectInfo(java.lang.String handle)` Gets the property information of the object.
`int` | `getObjectType(java.lang.String handle)` Gets the int type value of the object.
`java.lang.String[]` | `getParameter()` Gets all parameters in the default data source in the catalog.
`java.lang.String` | `getParent(java.lang.String handle)` Gets the container(parent) of the object.
`java.lang.String[]` | `getProcedures()` Gets Stored Procedures in the default data source in the catalog.
`java.lang.String[]` | `getProcedures(java.lang.String sourceName)` Gets Stored Procedures in the specified data source in the catalog.
`java.lang.String[]` | `getQueries()` Gets the queries in the default data source in the catalog.
`java.lang.String[]` | `getQueries(java.lang.String sourceName)` Gets the queries in the specified data source in the catalog.
`java.lang.String` | `getQueryName(java.lang.String handle)` Gets query name of a report.
`java.lang.String` | `getReporthome()` Gets the install root of the application,
`ReportSortInfo` | `getReportSortInfo(java.lang.String handle)` Gets the sort information of the report
`java.lang.String[]` | `getSections(java.lang.String handle)` Gets the handles of the sections in a report.
`java.lang.String[]` | `getSections(java.lang.String handle, boolean visible)` Gets the handles of the sections in a report.
`java.lang.String[]` | `getSections(java.lang.String handle, boolean visible, int type)` Gets the handles of the sections in a report.
`SortInfo[]` | `getSortInfo(java.lang.String handle)` Gets the sort information of the group or the report
`java.lang.String[]` | `getSQLs()` Gets Import SQLs in the default data source in the catalog.
`java.lang.String[]` | `getSQLs(java.lang.String sourceName)` Gets Import SQLs in the specified data source in the catalog.
`java.lang.String[]` | `getSummaries(java.lang.String handle)` Gets the summaries that can be used in the report.
`java.lang.String` | `getTableColumnHandle(java.lang.String tableHandle, int index)` Gets the specified table column's handle.
`int` | `getTableColumnIndex(java.lang.String columnHandle)` Gets the table column's index.
`double` | `getTableWidth(java.lang.String parent, TableTemplateInfo info)` Gets the preferred table width according to the specified TableTemplateInfo.
`java.lang.String` | `getTabularCell(java.lang.String tabular, int rowIndex, int colIndex)` Gets the handle of the cell in the specified tabular row or column.
`java.lang.String[]` | `getTabularColumnCells(java.lang.String tabular, int index)` Gets the handles of the cells in a specified tabular column.
`java.lang.String[]` | `getTabularRowCells(java.lang.String tabular, int index)` Gets the handles of the cells in a specified tabular row
`java.lang.String[]` | `getUDS()` Gets Import UDSs in the default data source in the catalog.
`java.lang.String[]` | `getUDS(java.lang.String sourceName)` Gets UDSs in the specified data source in the catalog.
`java.lang.String` | `getUID()` Gets the UserID of JReport Design API.
`java.lang.String` | `getUserID()` Gets user ID of the designer API instance.
`java.lang.String[]` | `getViews()` Gets the database Views in the default data source in the catalog.
`boolean` | `hasPageSecurity(java.lang.String handle)` Gets the status whether the report use page level security or not.
`boolean` | `hideTableColumn(java.lang.String table, int index)` Hides a table column.
`java.lang.String` | `insert(java.lang.String parent, ChartLegendInfo chartLegendInfo, java.lang.String paperName)` Inserts a chart object and its children into the parent node.
`java.lang.String` | `insert(java.lang.String parent, CTRowColFieldInfo colInfo, CTRowColFieldInfo rowInfo, CTAggFieldInfo aggInfo)` Deprecated. since version 8.0, replaced by `String , CrossTabInfo`.
`java.lang.String` | `insert(java.lang.String parent, int type, java.lang.String name)` Inserts an object into the parent node.
`java.lang.String` | `insert(java.lang.String parent, int type, java.lang.String name, GroupInfo groupInfo, SpecGroupInfo specGroupInfo)` Inserts a group/sort into the parent node.
`java.lang.String` | `insert(java.lang.String parent, int type, java.lang.String name, java.lang.String mapping)` Inserts an object of database field, parameter, formula , summary or group into the parent node.
`java.lang.String` | `insert(java.lang.String parent, int type, java.lang.String name, java.lang.String topSection, java.lang.String bottomSection)` Inserts a shape object such as box, line, arc, or oval into the report.
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, boolean avoid, boolean onleft, boolean ontop, boolean repeat, boolean vertical, int boundary, CTRowColFieldInfo[] colInfo, CTRowColFieldInfo[] rowInfo, CTAggFieldInfo[] aggInfo)` Deprecated. since version 8.0.Replaced by `insertCrossTab(String, CrossTabInfo)`
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, CTRowColFieldInfo[] colInfo, CTRowColFieldInfo[] rowInfo, CTAggFieldInfo[] aggInfo)` Deprecated. since version 8.0. Replaced by `insertCrossTab(String, CrossTabInfo)`
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, GroupInfo groupInfo)` Deprecated. since version 8.0. Replaced by `insertSectionGroup(group, groupInfo)`
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, int type, boolean isGroup, java.lang.String group1, java.lang.String group2, java.lang.String[] value)` Deprecated. since version 8.0. Replaced by `insertChart(String, ChartInfo)`
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, java.lang.String UDOname)` Inserts a UDO object into the parent node.
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, java.lang.String paperName, int type, boolean isGroup, java.lang.String group1, java.lang.String group2, java.lang.String[] value, ChartLegendInfo chartLegendInfo, ChartLabelInfo chartLabelInfo)` Inserts a chart object and its children into the parent node.
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, java.lang.String paperName, int type1, int type2, boolean isGroup, java.lang.String group1, java.lang.String group2, java.lang.String[] value, ChartLegendInfo chartLegendInfo, ChartLabelInfo chartLabelInfo)` Inserts a combo chart object and its children into the parent node.
`java.lang.String` | `insert(java.lang.String parent, java.lang.String name, java.lang.String paperName, int type, java.lang.String group1, java.lang.String group2, java.lang.String value, ChartLegendInfo chartLegendInfo, ChartLabelInfo chartLabelInfo)` Deprecated. since version 8.0. Replaced by `insertChart(String, ChartInfo)`
`java.lang.String` | `insertBandedObject(java.lang.String parent, boolean withHeader, boolean withFooter, boolean withDetail)` Inserts a Banded Object into a report.
`java.lang.String` | `insertChart(java.lang.String parent, ChartInfo info)` Inserts a chart into a report.
`java.lang.String` | `insertColumn(java.lang.String parent, int type, java.lang.String name, java.lang.String mapping, int index)` Deprecated. since version 8.0, replaced by `insertTableColumn(String, int, int, String, String, boolean, boolean)`.
`java.lang.String` | `insertCrossTab(java.lang.String parent, CrossTabInfo info)` Inserts a crosstab into the report.
`java.lang.String` | `insertCrossTabAggregations(java.lang.String crossTab, CTAggFieldInfo[] infos, int index)` Inserts aggregations into a crosstab
`java.lang.String` | `insertCrossTabColumns(java.lang.String crossTab, CTRowColFieldInfo[] infos, int index)` Inserts columns into a crosstab.
`java.lang.String` | `insertCrossTabRows(java.lang.String crossTab, CTRowColFieldInfo[] infos, int index)` Inserts rows into a crosstab
`java.lang.String` | `insertDetailPanel(java.lang.String parent, java.lang.String referredHandle, boolean isinsertedBefore)` Inserts a detail section object into a report.
`java.lang.String` | `insertField(java.lang.String parent, java.lang.String mappingName, java.lang.String blName, int fieldType, int renderType)` Inserts a field object into a report.
`java.lang.String` | `insertPage(java.lang.String reportHandle)` Inserts a page panel object into a report.
`java.lang.String` | `insertPageBreak(java.lang.String parent, java.lang.String referredHandle, boolean isinsertedBefore)` Inserts a page break object into a report.
`java.lang.String[]` | `insertPageStartEnd(java.lang.String pageHandle, java.lang.String parent, int startIndex, int endIndex)` Inserts a page control object into a report
`java.lang.String` | `insertSectionFooterPanel(java.lang.String parent, java.lang.String referredHandle, boolean isinsertedBefore)` Inserts a banded object section footer into a report
`java.lang.String` | `insertSectionGroup(java.lang.String parent, GroupInfo groupInfo)` Inserts a group object into a report.
`java.lang.String` | `insertSectionHeaderPanel(java.lang.String parent, java.lang.String referredHandle, boolean isinsertedBefore)` Inserts a banded object header section object into a report
`java.lang.String` | `insertSectionPanel(java.lang.String parent, java.lang.String referredHandle, int sectionType, boolean isinsertedBefore)` Inserts a banded object section into a report
`java.lang.String` | `insertShape(java.lang.String parent, Shape shape)` Inserts a geometry object into a report.
`java.lang.String` | `insertSubReport(java.lang.String parent, SubReportInfo info)` Inserts a Subreport into a report.
`java.lang.String` | `insertTable(java.lang.String parent, TableTemplateInfo info)` Inserts a new style (post V8) table into the report.
`java.lang.String` | `insertTable(java.lang.String parent, TableTemplateInfo info, boolean increasePanel)` Inserts a new style (post V8) table into the report.
`java.lang.String` | `insertTableColumn(java.lang.String table, int index, int direction)` Inserts a column into a new style table.
`java.lang.String` | `insertTableColumn(java.lang.String table, int index, int direction, java.lang.String fieldName, java.lang.String title, boolean increaseTable, boolean auotResetPage)` Inserts a column with fields into a new style table
`java.lang.String` | `insertTableGroup(java.lang.String table, java.lang.String parentGroup, java.lang.String mapping, java.lang.String blName)` Inserts a group into the table.
`java.lang.String` | `insertTabular(java.lang.String parent, java.lang.String tabularName, int colVol, int rowVol)` Inserts a new tabular object into a report.
`boolean` | `mergeTableCells(java.lang.String table, java.lang.String[] cellsid)` Merges table cells into one cell.
`java.lang.String` | `mergeTabularCells(java.lang.String tabular, java.lang.String[] cellsid)` Merges several tabular cells into one cell.
`java.lang.String` | `moveCrossTabAggregations(java.lang.String crossTab, int[] orignalIndex, int desIndex)` Adjusts crosstab aggregations' positions in the summary areas of a crosstab.
`java.lang.String` | `moveCrossTabColumns(java.lang.String crossTab, int[] orignalIndex, int desIndex)` Adjusts a crosstab's column order.
`java.lang.String` | `moveCrossTabRows(java.lang.String crossTab, int[] orignalIndex, int desIndex)` Adjusts a crosstab's row order.
`boolean` | `moveTableColumns(java.lang.String table, int[] index, int step, int direction)` Moves columns in a table
`java.lang.String` | `open(java.lang.String name)` Loads a report panel according to a report file name.
`boolean` | `pivotCrossTab(java.lang.String crossTab)` Pivots the crosstab.
`boolean` | `pivotTable(java.lang.String table, int colIndex1, int colIndex2)` Exchanges the specified table's columns.
`boolean` | `quit()` Quits from editing mode without saving any changes to the catalog and the reportsets.
`boolean` | `quit(java.lang.String handle)` Quits the specified report according to the report handle without any changes being saved.
`boolean` | `removeDisplayName(java.lang.String report, DisplayNameInfo displayNameInfo)` Removes a DisplayName object from a report.
`java.lang.String` | `removeTableGroup(java.lang.String table, java.lang.String group)` Removes the specified group from the table.
`boolean` | `resizeTable(java.lang.String table, int refPoint, double xPercentage, double yPercentage, boolean increasePanel)` Resizes the table in the specified rate.
`boolean` | `resizeTabular(java.lang.String tabular, int refPoint, double xPercentage, double yPercentage, boolean increasePanel)` Resizes the Tabular in the specified rate.
`java.lang.String` | `saveAs(java.lang.String handle, java.lang.String newname)` Saves a report as a new report file.
`boolean` | `saveSelfContainedReport(java.lang.String rptHandle, java.lang.String path, java.lang.String filename)` Saves the report as a self-contained report.
`boolean` | `saveSelfReport(java.lang.String path, java.lang.String name, java.lang.String newName)` Deprecated. since version 8.0,replaced by `saveSelfContainedReport(String, String, String )`.
`boolean` | `set(java.lang.String handle, java.lang.String name, float value)` Changes the property value of an object.
`boolean` | `set(java.lang.String handle, java.lang.String name, int value)` Changes the property value of an object.
`boolean` | `setControlFields(java.lang.String handle, java.lang.String prop, java.lang.String field)` Sets the field to control the property value at runtime.
`boolean` | `setCTAggFieldHeight(java.lang.String crossTab, int yDepth, int index, double height)` Sets the specified aggregation's height in a crosstab.
`boolean` | `setCTAggFieldWidth(java.lang.String crossTab, int xDepth, int index, double width)` Sets the specified aggregation's width in a crosstab.
`boolean` | `setCTAggTitleHeight(java.lang.String crossTab, int index, double height)` sets the height of a crosstab aggregation's title
`boolean` | `setCTAggTitleWidth(java.lang.String crossTab, int index, double width)` sets the width of a crosstab aggregation's title
`boolean` | `setCTColHeaderHeight(java.lang.String crossTab, int index, double height)` Sets the specified column header's cell height of a crosstab.
`boolean` | `setCTRowHeaderWidth(java.lang.String crossTab, int index, double width)` Sets the specified row header's cell width of crosstab.
`boolean` | `setDataset(java.lang.String objHandle, java.lang.String datasetHandle)` Applys a dataset to the report object.
`boolean` | `setDatasetBLFilter(java.lang.String datasetHandle, BLFilterInformation filterInfo)` Applys a JReport BusinessLogic filter to the dataset.
`boolean` | `setDefaultFormat(java.lang.String handle)` Sets a default object format for an object.
`void` | `setPageWidth(double width)` Sets the width of the page panel and also its sections.
`void` | `setReporthome(java.lang.String reporthome)` Sets the reporthome of the application.
`void` | `setReportSortInfo(java.lang.String handle, ReportSortInfo sortInfo)` Sets the sort information of the whole report
`void` | `setSortInfo(java.lang.String handle, SortInfo[] sortInfo)` Sets the sort information of the specified group
`boolean` | `setStyle(java.lang.String reportHandle, java.lang.String[] objectHandles, java.lang.String styleName, boolean isURL)` Sets css or a style to the report objects.
`boolean` | `setStyle(java.lang.String reportHandle, java.lang.String viewName, java.lang.String styleName)` Sets css or a style to the report.
`boolean` | `setTableColumnWidth(java.lang.String table, int index, double increment, boolean increaseTable, boolean increasePanel)` Resets the table column's width
`void` | `setUserInfo(java.lang.String uid, java.lang.String key)` Deprecated. since version 6.1.
`boolean` | `showTableColumn(java.lang.String table, int index)` Makes a hidden table column to be visible
`boolean` | `splitTabularCell(java.lang.String tabular, java.lang.String cellHandle, int rowVol, int clmVol)` Splits a tabular cell into a set of cells.
`void` | `updateDisplayName(java.lang.String report, DisplayNameInfo displayNameInfo)` Updates the properties of an existing DisplayName in a report.

Methods inherited from class jet.api.API
`clearError, clearMsg, clearWarning, closeLog, containPropName, getBool, getChildren, getClassType, getColor, getDouble, getError, getFloat, getHandles, getHandles, getHandles, getHandles, getInstanceName, getInt, getLong, getPropNames, getPropType, getQualifyName, getString, getStringArray, getUnit, getWarning, set, set, set, set, set, setLog, setLog, setLog, setReference, setUnit, writeLog, writeLog`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### REPORT

    public static final int REPORT

  Report object type.

  See Also:
    Constant Field Values

### PAGE

    public static final int PAGE

  Page container object type.

  See Also:
    Constant Field Values

### GROUP

    public static final int GROUP

  Group object type.

  See Also:
    Constant Field Values

### REPORTHEADER

    public static final int REPORTHEADER

  ReportHeader Section object type.

  See Also:
    Constant Field Values

### REPORTFOOTER

    public static final int REPORTFOOTER

  ReportFooter Section object type.

  See Also:
    Constant Field Values

### PAGEHEADER

    public static final int PAGEHEADER

  PageHeader Section object type.

  See Also:
    Constant Field Values

### PAGEFOOTER

    public static final int PAGEFOOTER

  PageFooter Section object type.

  See Also:
    Constant Field Values

### GROUPHEADER

    public static final int GROUPHEADER

  GroupHeader Section object type.

  See Also:
    Constant Field Values

### GROUPFOOTER

    public static final int GROUPFOOTER

  GroupFooter Section object type.

  See Also:
    Constant Field Values

### DETAIL

    public static final int DETAIL

  Detail Section object type.

  See Also:
    Constant Field Values

### LABEL

    public static final int LABEL

  Label Field object type.

  See Also:
    Constant Field Values

### DBFIELD

    public static final int DBFIELD

  Database Field object type.

  See Also:
    Constant Field Values

### COMPUTEDCOLUMN

    public static final int COMPUTEDCOLUMN

  ComputedColumn Field object type.

  See Also:
    Constant Field Values

### FORMULA

    public static final int FORMULA

  Formula Field object type.

  See Also:
    Constant Field Values

### SUMMARY

    public static final int SUMMARY

  Summary Field object type.

  See Also:
    Constant Field Values

### PARAMETER

    public static final int PARAMETER

  Parameter Field object type.

  See Also:
    Constant Field Values

### IMAGE

    public static final int IMAGE

  Image object type.

  See Also:
    Constant Field Values

### USERNAME

    public static final int USERNAME

  JReport Special Field object type

  See Also:
    Constant Field Values

### PRINTDATE

    public static final int PRINTDATE

  JReport Special Field object type

  See Also:
    Constant Field Values

### PRINTTIME

    public static final int PRINTTIME

  JReport Special Field object type

  See Also:
    Constant Field Values

### FETCHDATE

    public static final int FETCHDATE

  JReport Special Field object type

  See Also:
    Constant Field Values

### FETCHTIME

    public static final int FETCHTIME

  JReport Special Field object type

  See Also:
    Constant Field Values

### MODIFIEDDATE

    public static final int MODIFIEDDATE

  JReport Special Field object type

  See Also:
    Constant Field Values

### MODIFIEDTIME

    public static final int MODIFIEDTIME

  JReport Special Field object type

  See Also:
    Constant Field Values

### RECORDNUMBER

    public static final int RECORDNUMBER

  JReport Special Field object type

  See Also:
    Constant Field Values

### GROUPNAME

    public static final int GROUPNAME

  JReport Special Field object type

  See Also:
    Constant Field Values

### GROUPNUMBER

    public static final int GROUPNUMBER

  JReport Special Field object type

  See Also:
    Constant Field Values

### GROUPNUMBERS

    public static final int GROUPNUMBERS

  JReport Special Field object type

  See Also:
    Constant Field Values

### PAGENUMBER

    public static final int PAGENUMBER

  JReport Special Field object type

  See Also:
    Constant Field Values

### PAGENUMBERS

    public static final int PAGENUMBERS

  JReport Special Field object type

  See Also:
    Constant Field Values

### SQLSTATMENT

    public static final int SQLSTATMENT

  JReport Special Field object type

  See Also:
    Constant Field Values

### TEXT

    public static final int TEXT

  JReport TextArea object type.

  See Also:
    Constant Field Values

### CHARTLABEL

    public static final int CHARTLABEL

  Combinatorial Chart Label object type

  See Also:
    Constant Field Values

### CHARTLEGEND

    public static final int CHARTLEGEND

  Combinatorial Chart Legend object type.

  See Also:
    Constant Field Values

### CHARTPLATFORM

    public static final int CHARTPLATFORM

  Combinatorial Chart Platform object type.

  See Also:
    Constant Field Values

### CHARTCOORDINATEPAPER

    public static final int CHARTCOORDINATEPAPER

  Combinatorial Chart CoordinatePaper object type.

  See Also:
    Constant Field Values

### CROSSTAB

    public static final int CROSSTAB

  Combinatorial Crosstab object type.

  See Also:
    Constant Field Values

### CTAGGFIELD

    public static final int CTAGGFIELD

  Combinatorial Crosstab Aggregation Field object type.

  See Also:
    Constant Field Values

### CTAGGINFO

    public static final int CTAGGINFO

  Combinatorial Crosstab AggregationInfo object type.

  See Also:
    Constant Field Values

### CTDBFIELD

    public static final int CTDBFIELD

  Combinatorial Crosstab Field object type.

  See Also:
    Constant Field Values

### CTHDDBFIELD

    public static final int CTHDDBFIELD

  Combinatorial Crosstab Header Field object type.

  See Also:
    Constant Field Values

### CTHDTEXTFIELD

    public static final int CTHDTEXTFIELD

  Combinatorial Crosstab HeaderText Field object type.

  See Also:
    Constant Field Values

### SUBREPORT

    public static final int SUBREPORT

  Subreport object type.

  See Also:
    Constant Field Values

### SUBLINK

    public static final int SUBLINK

  SubreportLink object type.

  See Also:
    Constant Field Values

### SUBPARAMLINK

    public static final int SUBPARAMLINK

  Subreport ParamterLink object type.

  See Also:
    Constant Field Values

### SUBRETVALUE

    public static final int SUBRETVALUE

  Subreport ReturnValue object type .

  See Also:
    Constant Field Values

### LINE

    public static final int LINE

  Shape object type.

  See Also:
    Constant Field Values

### BOX

    public static final int BOX

  Shape object type.

  See Also:
    Constant Field Values

### ROUNDBOX

    public static final int ROUNDBOX

  Shape object type.

  See Also:
    Constant Field Values

### OVAL

    public static final int OVAL

  Shape object type.

  See Also:
    Constant Field Values

### ARC

    public static final int ARC

  Shape object type.

  See Also:
    Constant Field Values

### RPTDATASOURCE

    public static final int RPTDATASOURCE

  Report Datasource object type

  See Also:
    Constant Field Values

### JHYPERLINK

    public static final int JHYPERLINK

  JReport UDO object type

  See Also:
    Constant Field Values

### JBROWSER

    public static final int JBROWSER

  JReport UDO object type

  See Also:
    Constant Field Values

### DATAOBJECT

    public static final int DATAOBJECT

  DataContainer object type.

  See Also:
    Constant Field Values

### TABLE

    public static final int TABLE

  Deprecated.
  Table object type.

  See Also:
    Constant Field Values

### COLUMN

    public static final int COLUMN

  Table Column object type.

  See Also:
    Constant Field Values

### MEDIAFIELD

    public static final int MEDIAFIELD

  JReport MediaField object type.

  See Also:
    Constant Field Values

### UDO

    public static final int UDO

  JReport UDO object type.

  See Also:
    Constant Field Values

### CHART2DCOORDINATEPAPER

    public static final int CHART2DCOORDINATEPAPER

  Combinatorial 2D Chart CoordinatePaper object type.

  See Also:
    Constant Field Values

### BARCODEFIELD

    public static final int BARCODEFIELD

  JReport BarCode object type.

  See Also:
    Constant Field Values

### PAGENOFM

    public static final int PAGENOFM

  Special Field object types.

  See Also:
    Constant Field Values

### NEWSTYLETABLE

    public static final int NEWSTYLETABLE

  Table object type.

  See Also:
    Constant Field Values

### TABLECELL

    public static final int TABLECELL

  Table cell object type.

  See Also:
    Constant Field Values

### REPORTSET

    public static final int REPORTSET

  ReportSet object type.

  See Also:
    Constant Field Values

### DATASET

    public static final int DATASET

  DataSet object type.

  See Also:
    Constant Field Values

### REPORTBODY

    public static final int REPORTBODY

  ReportBody object type.

  See Also:
    Constant Field Values

### PARAGRAPH

    public static final int PARAGRAPH

  Container object type.

  See Also:
    Constant Field Values

### TEXTBOX

    public static final int TEXTBOX

  TextBox object type.

  See Also:
    Constant Field Values

### MULTI_VALUE_BOX

    public static final int MULTI_VALUE_BOX

  Container object type.

  See Also:
    Constant Field Values

### PARALLELDETAIL

    public static final int PARALLELDETAIL

  Parallel Detail Section object type.

  See Also:
    Constant Field Values

### PAGEBREAK

    public static final int PAGEBREAK

  JReport PageBreak object type.

  See Also:
    Constant Field Values

### PAGESTART

    public static final int PAGESTART

  JReport PageStart object type.

  See Also:
    Constant Field Values

### PAGEEND

    public static final int PAGEEND

  JReport PageEnd object type.

  See Also:
    Constant Field Values

### REPORTSHEET

    public static final int REPORTSHEET

  Report object type.

  See Also:
    Constant Field Values

### TABULARCELL

    public static final int TABULARCELL

  JReport Tabula object type.

  See Also:
    Constant Field Values

### BANDEDOBJECT

    public static final int BANDEDOBJECT

  JReport BandedObject object type.

  See Also:
    Constant Field Values

### BANDEDOBJECT_PAGEHEADER

    public static final int BANDEDOBJECT_PAGEHEADER

  BandedObject PageHeader Section object type.

  See Also:
    Constant Field Values

### BANDEDOBJECT_PAGEFOOTER

    public static final int BANDEDOBJECT_PAGEFOOTER

  BandedObject PageFooter Section object type.

  See Also:
    Constant Field Values

### BANDEDOBJECT_HEADER

    public static final int BANDEDOBJECT_HEADER

  BandedObjectHeader Section object type.

  See Also:
    Constant Field Values

### BANDEDOBJECT_FOOTER

    public static final int BANDEDOBJECT_FOOTER

  BandedObjectFooter Section object type.

  See Also:
    Constant Field Values

### SHAPE

    public static final int SHAPE

  Shape object type.

  See Also:
    Constant Field Values

### TABLE_COMMONCOLUMN

    public static final int TABLE_COMMONCOLUMN

  Table COMMON column object type.

  See Also:
    Constant Field Values

### TABLE_GROUPCOLUMN

    public static final int TABLE_GROUPCOLUMN

  Table GROUP column object type.

  See Also:
    Constant Field Values

### TABLE_DETAILCOLUMN

    public static final int TABLE_DETAILCOLUMN

  Table DETAIL column object type.

  See Also:
    Constant Field Values

### TABLE_SUMMARYCOLUMN

    public static final int TABLE_SUMMARYCOLUMN

  Table SUMMARY column object type.

  See Also:
    Constant Field Values

### TABLE_HEADERSECTION

    public static final int TABLE_HEADERSECTION

  TableHeader Section object type.

  See Also:
    Constant Field Values

### TABLE_DETAILSECTION

    public static final int TABLE_DETAILSECTION

  TableDetail Section object type.

  See Also:
    Constant Field Values

### TABLE_FOOTERSECTION

    public static final int TABLE_FOOTERSECTION

  TableFooter Section object type.

  See Also:
    Constant Field Values

### TABLE_GROUP_HEADERSECTION

    public static final int TABLE_GROUP_HEADERSECTION

  Table GroupHeader section object type.

  See Also:
    Constant Field Values

### TABLE_GROUP_FOOTERSECTION

    public static final int TABLE_GROUP_FOOTERSECTION

  Table GroupFooter section object type.

  See Also:
    Constant Field Values

### FIELD_REPORTPATH_ONSERVER

    public static final int FIELD_REPORTPATH_ONSERVER

  JReport Special Field object types.

  See Also:
    Constant Field Values

### FIELD_REPORTPATH_ONDISK

    public static final int FIELD_REPORTPATH_ONDISK

  JReport Special Field object types.

  See Also:
    Constant Field Values

### FIELD_CATALOGPATH_ONSERVER

    public static final int FIELD_CATALOGPATH_ONSERVER

  JReport Special Field object types.

  See Also:
    Constant Field Values

### FIELD_CATALOGPATH_ONDISK

    public static final int FIELD_CATALOGPATH_ONDISK

  JReport Special Field object types.

  See Also:
    Constant Field Values

### BARCHART

    public static final int BARCHART

  The chart type value.

  See Also:
    Constant Field Values

### SIDEBYSIDEBARCHART

    public static final int SIDEBYSIDEBARCHART

  The chart type value.

  See Also:
    Constant Field Values

### STACKEDBARCHART

    public static final int STACKEDBARCHART

  The chart type value.

  See Also:
    Constant Field Values

### BENCHARRAYCHART

    public static final int BENCHARRAYCHART

  The chart type value.

  See Also:
    Constant Field Values

### BENCHCHART

    public static final int BENCHCHART

  The chart type value.

  See Also:
    Constant Field Values

### STACKEDBENCH

    public static final int STACKEDBENCH

  The chart type value.

  See Also:
    Constant Field Values

### PIECHART

    public static final int PIECHART

  The chart type value.

  See Also:
    Constant Field Values

### LINECHART

    public static final int LINECHART

  The chart type value.

  See Also:
    Constant Field Values

### AREACHART

    public static final int AREACHART

  The chart type value.

  See Also:
    Constant Field Values

### BAR_SIDEBYSIDE_2D

    public static final int BAR_SIDEBYSIDE_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_STACK_2D

    public static final int BAR_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_PERCENT_2D

    public static final int BAR_PERCENT_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_SIDEBYSIDE_3D

    public static final int BAR_SIDEBYSIDE_3D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_STACK_3D

    public static final int BAR_STACK_3D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_PERCENT_3D

    public static final int BAR_PERCENT_3D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_ARRAY_3D

    public static final int BAR_ARRAY_3D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_SIDEBYSIDE_2D

    public static final int BENCH_SIDEBYSIDE_2D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_STACK_2D

    public static final int BENCH_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_PERCENT_2D

    public static final int BENCH_PERCENT_2D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_SIDEBYSIDE_3D

    public static final int BENCH_SIDEBYSIDE_3D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_STACK_3D

    public static final int BENCH_STACK_3D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_PERCENT_3D

    public static final int BENCH_PERCENT_3D

  The chart type value.

  See Also:
    Constant Field Values

### BENCH_ARRAY_3D

    public static final int BENCH_ARRAY_3D

  The chart type value.

  See Also:
    Constant Field Values

### LINE_ARRAY_2D

    public static final int LINE_ARRAY_2D

  The chart type value.

  See Also:
    Constant Field Values

### LINE_STACK_2D

    public static final int LINE_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### LINE_PERCENT_2D

    public static final int LINE_PERCENT_2D

  The chart type value.

  See Also:
    Constant Field Values

### LINE_ARRAY_3D

    public static final int LINE_ARRAY_3D

  The chart type value.

  See Also:
    Constant Field Values

### AREA_STACK_2D

    public static final int AREA_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### AREA_PERCENT_2D

    public static final int AREA_PERCENT_2D

  The chart type value.

  See Also:
    Constant Field Values

### AREA_STACK_3D

    public static final int AREA_STACK_3D

  The chart type value.

  See Also:
    Constant Field Values

### AREA_PERCENT_3D

    public static final int AREA_PERCENT_3D

  The chart type value.

  See Also:
    Constant Field Values

### PIE_SIDEBYSIDE_2D

    public static final int PIE_SIDEBYSIDE_2D

  The chart type value.

  See Also:
    Constant Field Values

### PIE_SIDEBYSIDE_3D

    public static final int PIE_SIDEBYSIDE_3D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_SIDEBYSIDE_LINE_ARRAY_2D

    public static final int BAR_SIDEBYSIDE_LINE_ARRAY_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_STACK_LINE_ARRAY_2D

    public static final int BAR_STACK_LINE_ARRAY_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_PERCENT_LINE_ARRAY_2D

    public static final int BAR_PERCENT_LINE_ARRAY_2D

  The chart type value.

  See Also:
    Constant Field Values

### LINE_ARRAY_LINE_ARRAY_2D

    public static final int LINE_ARRAY_LINE_ARRAY_2D

  The chart type value.

  See Also:
    Constant Field Values

### AREA_ARRAY_2D

    public static final int AREA_ARRAY_2D

  The chart type value.

  See Also:
    Constant Field Values

### AREA_ARRAY_3D

    public static final int AREA_ARRAY_3D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_SIDEBYSIDE_LINE_STACK_2D

    public static final int BAR_SIDEBYSIDE_LINE_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_STACK_LINE_STACK_2D

    public static final int BAR_STACK_LINE_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_PERCENT_LINE_STACK_2D

    public static final int BAR_PERCENT_LINE_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_SIDEBYSIDE_AREA_STACK_2D

    public static final int BAR_SIDEBYSIDE_AREA_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_STACK_AREA_STACK_2D

    public static final int BAR_STACK_AREA_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### BAR_PERCENT_AREA_STACK_2D

    public static final int BAR_PERCENT_AREA_STACK_2D

  The chart type value.

  See Also:
    Constant Field Values

### STOCK_HIGH_LOW_CLOSE_2D

    public static final int STOCK_HIGH_LOW_CLOSE_2D

  The chart type value.

  See Also:
    Constant Field Values

### STOCK_OPEN_HIGH_LOW_CLOSE_2D

    public static final int STOCK_OPEN_HIGH_LOW_CLOSE_2D

  The chart type value.

  See Also:
    Constant Field Values

### RADAR_2D

    public static final int RADAR_2D

  The chart type value.

  See Also:
    Constant Field Values

### SCATTER_POINTS_2D

    public static final int SCATTER_POINTS_2D

  The chart type value.

  See Also:
    Constant Field Values

### SCATTER_SMOOTH_LINES_2D

    public static final int SCATTER_SMOOTH_LINES_2D

  The chart type value.

  See Also:
    Constant Field Values

### SCATTER_STRAIGHT_LINES_2D

    public static final int SCATTER_STRAIGHT_LINES_2D

  The chart type value.

  See Also:
    Constant Field Values

### BUBBLE_2D

    public static final int BUBBLE_2D

  The chart type value.

  See Also:
    Constant Field Values

### GAUGE_DIALS_2D

    public static final int GAUGE_DIALS_2D

  The chart type value.

  See Also:
    Constant Field Values

### GAUGE_BARS_2D

    public static final int GAUGE_BARS_2D

  The chart type value.

  See Also:
    Constant Field Values

### GAUGE_BALLS_2D

    public static final int GAUGE_BALLS_2D

  The chart type value.

  See Also:
    Constant Field Values

### SURFACE_3D

    public static final int SURFACE_3D

  The chart type value.

  See Also:
    Constant Field Values

### STOCK_HIGH_LOW_2D

    public static final int STOCK_HIGH_LOW_2D

  The chart type value.

  See Also:
    Constant Field Values

### UPC_A

    public static final int UPC_A

  The Barcode type value.

  See Also:
    Constant Field Values

### UPC_E

    public static final int UPC_E

  The Barcode type value.

  See Also:
    Constant Field Values

### EAN_13

    public static final int EAN_13

  The Barcode type value.

  See Also:
    Constant Field Values

### EAN_8

    public static final int EAN_8

  The Barcode type value.

  See Also:
    Constant Field Values

### CODE_39

    public static final int CODE_39

  The Barcode type value.

  See Also:
    Constant Field Values

### CODE_128

    public static final int CODE_128

  The Barcode type value.

  See Also:
    Constant Field Values

### CODABAR

    public static final int CODABAR

  The Barcode type value.

  See Also:
    Constant Field Values

### LEFTTOP

    public static final int LEFTTOP

  The alignment type value.

  See Also:
    Constant Field Values

### CENTERTOP

    public static final int CENTERTOP

  The alignment type value.

  See Also:
    Constant Field Values

### RIGHTTOP

    public static final int RIGHTTOP

  The alignment type value.

  See Also:
    Constant Field Values

### LEFTCENTER

    public static final int LEFTCENTER

  The alignment type value.

  See Also:
    Constant Field Values

### CENTERCENTER

    public static final int CENTERCENTER

  The alignment type value.

  See Also:
    Constant Field Values

### RIGHTCENTER

    public static final int RIGHTCENTER

  The alignment type value.

  See Also:
    Constant Field Values

### LEFTBOTTOM

    public static final int LEFTBOTTOM

  The alignment type value.

  See Also:
    Constant Field Values

### CENTERBOTTOM

    public static final int CENTERBOTTOM

  The alignment type value.

  See Also:
    Constant Field Values

### RIGHTBOTTOM

    public static final int RIGHTBOTTOM

  The alignment type value.

  See Also:
    Constant Field Values

### JUSTIFYTOP

    public static final int JUSTIFYTOP

  The alignment type value.

  See Also:
    Constant Field Values

### JUSTIFYCENTER

    public static final int JUSTIFYCENTER

  The alignment type value.

  See Also:
    Constant Field Values

### JUSTIFYBOTTOM

    public static final int JUSTIFYBOTTOM

  The alignment type value.

  See Also:
    Constant Field Values

### LEFT_UPSIDE_POINT

    public static final int LEFT_UPSIDE_POINT

  The resize direction value.

  See Also:
    Constant Field Values

### LEFT_UNDERSIDE_POINT

    public static final int LEFT_UNDERSIDE_POINT

  The resize direction value.

  See Also:
    Constant Field Values

### RIGHT_UPSIDE_POINT

    public static final int RIGHT_UPSIDE_POINT

  The resize direction value.

  See Also:
    Constant Field Values

### RIGHT_UNDERSIDE_POINT

    public static final int RIGHT_UNDERSIDE_POINT

  The resize direction value.

  See Also:
    Constant Field Values

### LEFT

    public static final int LEFT

  The moving direction value.

  See Also:
    Constant Field Values

### RIGHT

    public static final int RIGHT

  The moving direction value.

  See Also:
    Constant Field Values

### DIRECTION_FORESIDE

    public static final int DIRECTION_FORESIDE

  The direction value.

  See Also:
    Constant Field Values

### DIRECTION_BACKSIDE

    public static final int DIRECTION_BACKSIDE

  The type values.

  See Also:
    Constant Field Values

### RENDER_TEXT

    public static final int RENDER_TEXT

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_RANK

    public static final int RENDER_RANK

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_BARCODE

    public static final int RENDER_BARCODE

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_IMAGE

    public static final int RENDER_IMAGE

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_TEXTFIELD

    public static final int RENDER_TEXTFIELD

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_TEXTAREA

    public static final int RENDER_TEXTAREA

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_CHECKBOX

    public static final int RENDER_CHECKBOX

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_RADIOBTN

    public static final int RENDER_RADIOBTN

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_LIST

    public static final int RENDER_LIST

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_DROPDOWNLIST

    public static final int RENDER_DROPDOWNLIST

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_IMAGEBUTTON

    public static final int RENDER_IMAGEBUTTON

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_BUTTON

    public static final int RENDER_BUTTON

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_SUBMITBUTTON

    public static final int RENDER_SUBMITBUTTON

  The field render type constant.

  See Also:
    Constant Field Values

### RENDER_RESETBUTTON

    public static final int RENDER_RESETBUTTON

  The field render type constant.

  See Also:
    Constant Field Values

### DATASET_TYPE_QUERY

    public static final int DATASET_TYPE_QUERY

  The Dataset type constant.

  See Also:
    Constant Field Values

### DATASET_TYPE_HDS

    public static final int DATASET_TYPE_HDS

  The Dataset type constant.

  See Also:
    Constant Field Values

### DATASET_TYPE_ONDEMAND

    public static final int DATASET_TYPE_ONDEMAND

  The Dataset type constant.

  See Also:
    Constant Field Values

### ZORDER_TOP

    public static final int ZORDER_TOP

  The z-order type constant.

  See Also:
    Constant Field Values

### ZORDER_BOTTOM

    public static final int ZORDER_BOTTOM

  The z-order type constant.

  See Also:
    Constant Field Values

### ZORDER_BACKWARD

    public static final int ZORDER_BACKWARD

  The z-order type constant.

  See Also:
    Constant Field Values

### ZORDER_FORWARD

    public static final int ZORDER_FORWARD

  The z-order type constant.

  See Also:
    Constant Field Values

Constructor Detail

### Designer

    public Designer(java.lang.String path,
                    java.lang.String name)
             throws jet.jetc.ReadFailureException,
                    jet.universe.exception.UniverseFileException

  Deprecated. since version 6.1. Replaced by `Designer(String, String, DesignerUserInfo)`

  Constructor. Creates a Designer class instance. The Designer loads the catalog object with the specified catalog file's path and name. If the catalog file does not exist, a new catalog will be created. This can not load the XML format catalog.

  Parameters:
    `path` - Indicates the path of the catalog file.
    `name` - Indicates the name of the catalog file.
  Throws:
    `jet.jetc.ReadFailureException`
    `jet.universe.exception.UniverseFileException`

### Designer

    public Designer(java.lang.String path,
                    java.lang.String name,
                    DesignerUserInfo user)
             throws jet.jetc.ReadFailureException,
                    jet.universe.exception.UniverseFileException

  Constructor. Creates a Designer class instance. The Designer loads the catalog object with the specified catalog file's path and name. If the catalog file does not exist, a new catalog will be created.

  Parameters:
    `path` - Indicates the path of the catalog file.
    `name` - Indicates the name of the catalog file.
    `user` - The DesignerUserInfo includes the product license of Design API.
  Throws:
    `jet.jetc.ReadFailureException`
    `jet.universe.exception.UniverseFileException`
  Since:
    version 6.1.

### Designer

    public Designer(java.lang.String path,
                    java.lang.String name,
                    java.lang.String suffix)
             throws jet.jetc.ReadFailureException,
                    jet.universe.exception.UniverseFileException

  Deprecated. since version 6.1.

  Constructor. Creates a Designer class instance. The Designer loads the catalog object with the specified catalog file's path and name. If the catalog file does not exist, a new catalog will be created.

  Parameters:
    `path` - Indicates the path of the catalog file.
    `name` - Indicates the name of the catalog file.
    `suffix` - Indicates the suffix of the catalog file. Design API can save a catalog in binary or XML format. The suffix can be `XMLCAT` or `CAT`.
  Throws:
    `jet.jetc.ReadFailureException`
    `jet.universe.exception.UniverseFileException`

### Designer

    public Designer(java.lang.String path,
                    java.lang.String name,
                    java.lang.String suffix,
                    DesignerUserInfo user)
             throws jet.jetc.ReadFailureException,
                    jet.universe.exception.UniverseFileException

  Constructor. Creates a Designer class instance. The Designer loads the catalog object with the specified catalog file's path and name. If the catalog file does not exist, a new catalog will be created.

  Parameters:
    `path` - Indicates the path of the catalog file.
    `name` - Indicates the name of the catalog file.
    `user` - The DesignerUserInfo includes the product license of Design API.
    `suffix` - Indicates the suffix of the catalog file. Design API can save a catalog in binary or XML format. The suffix can be `XMLCAT` or `CAT`.
  Throws:
    `jet.jetc.ReadFailureException`
    `jet.universe.exception.UniverseFileException`
  Since:
    version 6.1.

Method Detail

### setUserInfo

    public void setUserInfo(java.lang.String uid,
                            java.lang.String key)

  Deprecated. since version 6.1.

  Sets license to Design API instance.

  Parameters:
    `uid` - the UserID of Design API.
    `key` - the key of Design API.

### getUID

    public java.lang.String getUID()

  Gets the UserID of JReport Design API.

### getKey

    public java.lang.String getKey()

  Gets the key of JReport Design API.

### getUserID

    public java.lang.String getUserID()

  Gets user ID of the designer API instance.

  Returns:
    userID String

### getCatalogAPI

    public CatalogAPI getCatalogAPI()

  Gets a CatalogAPI instance with the specified catalog.

  Returns:
    a reference of CatalogAPI. If fails, a null value will be returned, you can use `getError()` to check the error message.

### exitAndSave

    public void exitAndSave()

  Exits from editing mode. In this process, Design API saves all changes to the catalog and the reportsets, releases all the resources, and closes the catalog and all reportsets. Since there is a subtask of compiling formulas while saving the catalog, a FMLFileException may be thrown, then it still save the catalog without compiling the formulas.

### exit

    public void exit()

  Exits from editing mode. In this process, Design API saves all changes to the catalog and the reportsets, releases all the resources, and closes the catalog and all reportsets. Since there is a subtask of compiling formulas while saving a catalog, an FMLFileException may be thrown. If so, it only saves the reportsets without the catalog.

### quit

    public boolean quit()

  Quits from editing mode without saving any changes to the catalog and the reportsets. It releases all the resources, including the catalog and the reportsets.

  Returns:
    `true` if the catalog and the reportsets were closed successfully; `false` otherwise.

### create

    public java.lang.String create(java.lang.String name,
                                   java.lang.String query)

  Deprecated. since version 8.0, replaced by `createReportSet(String)`.

  Creates a new report with a report name. Since JReport enhanced the report structure, this report panel will be converted to a Banded Object automatically after the report is saved.

  Parameters:
    `name` - indicates the instance name of the report to be created.
    `query` - indicates the mapping name of the query in the default data source which is bound to the report.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  See Also:
    `addReport(String, String)`

### create

    public java.lang.String create(java.lang.String name,
                                   java.lang.String sourceName,
                                   java.lang.String query)

  Deprecated. since version 8.0, replaced by `createReportSet(String)`.

  Creates a new report with a report name. Since JReport enhanced the report structure, this report panel will be converted to a Banded Object automatically after the report is saved.

  Parameters:
    `name` - indicates the instance name of the report to be created.
    `sourceName` - indicates the name of the data source on which the query is based.
    `query` - indicates the mapping name of the query in the specified data source which is bound to the report.
  Returns:
    handle of the newly created report. If fails, a null value will be returned, and you can use `getError()` to check the error message.
  See Also:
    `addReport(String, String)`

### deleteReport

    public boolean deleteReport(java.lang.String name)

  Deprecated. since version 8.0, replaced by `deleteReportFile(String)`.

  Deletes a reportset file with the given file path and name.

  Parameters:
    `name` - Indicates the name of the existing report to be deleted.
  Returns:
    `true` if the report is successfully removed; `false`otherwise.

### deleteReportFile

    public boolean deleteReportFile(java.lang.String name)

  Deletes a reportset file with a file name.

  Parameters:
    `name` - the name of the existing reportset file to be deleted.
  Returns:
    true if the reportset is successfully removed. Otherwise returns false.

### open

    public java.lang.String open(java.lang.String name)

  Loads a report panel according to a report file name.

  Parameters:
    `name` - Indicates the file name of the report to be loaded.
  Returns:
    the report's handle when successful; otherwise `null` if the object load failed. Use `API.getError()` to get the reason for the error.

### hasPageSecurity

    public boolean hasPageSecurity(java.lang.String handle)

  Gets the status whether the report use page level security or not.

  Parameters:
    `handle` - Indicates the handle of the report panel
  Returns:
    `true` if the report use page level security; `false` otherwise.

### close

    public boolean close(java.lang.String handle)

  Closes a report panel according to a report handle. The report panel will be converted to a reportset and all changes of the report will be saved. All resources of the report will be released.

  Parameters:
    `handle` - Indicates the handle of the report panel.
  Returns:
    `true` if the report is saved successfully; `false` otherwise.
  See Also:
    `closeReportSet()`

### closeReportSet

    public boolean closeReportSet()

  Closes the current reportset and saves the changes.

  Returns:
    `true` if the reportset is saved successfully; `false` otherwise.

### quit

    public boolean quit(java.lang.String handle)

  Quits the specified report according to the report handle without any changes being saved.

  Parameters:
    `handle` - handle of the open report.
  Returns:
    `true` if the report is closed successfully; `false` otherwise.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   int type,
                                   java.lang.String name)

  Inserts an object into the parent node. Only the objects that are not bound to the data source can be inserted into the specified parent container, such as sections, labels, shapes, and special fields.

  Parameters:
    `parent` - Indicates the handle of the parent node. The handle should be a container, such as a report header.
    `type` - Indicates the type of the object to be inserted. The useful constants:
    - `REPORTHEADER`
    - `REPORTFOOTER`
    - `PAGEHEADER`
    - `PAGEFOOTER`
    - `GROUPHEADER`
    - `GROUPFOOTER`
    - `DETAIL`
    - `LABEL`
    - `IMAGE`
    - `USERNAME`
    - `PRINTDATE`
    - `PRINTTIME`
    - `FETCHDATE`
    - `FETCHTIME`
    - `MODIFIEDDATE`
    - `MODIFIEDTIME`
    - `RECORDNUMBER`
    - `GROUPNAME`
    - `GROUPNUMBER`
    - `GROUPNUMBERS`
    - `PAGENUMBER`
    - `PAGENUMBERS`
    - `SQLSTATMENT`
    - `LINE`
    - `BOX`
    - `ROUNDBOX`
    - `OVAL`
    - `ARC`
    `name` - Indicates the instance name of the new object.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   java.lang.String UDOname)

  Inserts a UDO object into the parent node.

  Parameters:
    `parent` - Indicates the handle of the parent node. The handle should be of a container, such as a report header.
    `name` - Indicates the instance name of the new object.
    `UDOname` - Indicates the UDO name.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   int type,
                                   java.lang.String name,
                                   java.lang.String mapping)

  Inserts an object of database field, parameter, formula , summary or group into the parent node.

  Parameters:
    `parent` - Indicates the handle of the parent node. The handle should be of a container, such as a report header.
    `type` - Indicates the type of the object to be inserted. The useful constants:
    - `GROUP`
    - `MEDIAFIELD`
    - `BARCODEFIELD`
    - `DBFIELD`
    - `FORMULA`
    - `SUMARY`
    - `PARAMETER`
    - `COMPUTEDCOLUMN`
    `name` - Indicates the instance name of the new object.
    `mapping` - Indicates the mapping name of the database field, parameter, formula or summary.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insertColumn

    public java.lang.String insertColumn(java.lang.String parent,
                                         int type,
                                         java.lang.String name,
                                         java.lang.String mapping,
                                         int index)

  Deprecated. since version 8.0, replaced by `insertTableColumn(String, int, int, String, String, boolean, boolean)`.

  Inserts a column into a table.

  Parameters:
    `parent` - the table handle
    `type` - the inserted field type
    `name` - the inserted object's name
    `mapping` - the inserted field's resource name
    `index` - the column index
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   CTRowColFieldInfo[] colInfo,
                                   CTRowColFieldInfo[] rowInfo,
                                   CTAggFieldInfo[] aggInfo)

  Deprecated. since version 8.0. Replaced by `insertCrossTab(String, CrossTabInfo)`

  Inserts a crosstab object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new object.
    `colInfo` - field info array of the column. The index value of colInfo[n] is ignored.
    `rowInfo` - field info array of the row. The index value of rowInfo[n] is ignored.
    `aggInfo` - field info array of the aggregate. The index value of aggInfo[n] is ignored.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   boolean avoid,
                                   boolean onleft,
                                   boolean ontop,
                                   boolean repeat,
                                   boolean vertical,
                                   int boundary,
                                   CTRowColFieldInfo[] colInfo,
                                   CTRowColFieldInfo[] rowInfo,
                                   CTAggFieldInfo[] aggInfo)

  Deprecated. since version 8.0.Replaced by `insertCrossTab(String, CrossTabInfo)`

  Inserts a crosstab object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new object.
    `avoid` - keeps columns together when page break.
    `onleft` - displays the aggregate calculation of the row on the left of the crosstab
    `ontop` - displays the aggregate calculation of the column on the top of the crosstab
    `repeat` - repeats the column titles when page break
    `vertical` - sets the layout of aggregate calculations vertically
    `boundary` - sets the number of aggregate calculations in a row or a column.
    `colInfo` - field info array of column. The index value of colInfo[n] is ignored.
    `rowInfo` - field info array of row. The index value of rowInfo[n] is ignored.
    `aggInfo` - field info array of aggregate. The index value of aggInfo[n] is ignored.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   CTRowColFieldInfo colInfo,
                                   CTRowColFieldInfo rowInfo,
                                   CTAggFieldInfo aggInfo)

  Deprecated. since version 8.0, replaced by `String , CrossTabInfo`.

  Inserts the crosstab's children into the crosstab.

  Parameters:
    `parent` - handle of the crosstab node.
    `colInfo` - field info array of Column. The index value of colInfo indicates the position at the Column. If the index value is less than zero or larger than the column size, the new column will be added to the end.
    `rowInfo` - field info array of Row. The index value of rowInfo indicates the position at the Row. If the index value is less than zero or larger than the row size, the new row will be added to the end.
    `aggInfo` - field info array of Aggregate. The index value of aggInfo indicates the position at a cell. If the index value is less than zero or larger than the aggregate size, the new aggregate will be added to the end.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   java.lang.String paperName,
                                   int type,
                                   java.lang.String group1,
                                   java.lang.String group2,
                                   java.lang.String value,
                                   ChartLegendInfo chartLegendInfo,
                                   ChartLabelInfo chartLabelInfo)

  Deprecated. since version 8.0. Replaced by `insertChart(String, ChartInfo)`

  Inserts a chart object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new chart.
    `paperName` - the instance name of ChartCoordinatepaper object
    `type` - type of the chart to be inserted
    `group1` - mapping name of the first group.
    `group2` - mapping name of the second group. It can be null.
    `value` - mapping name of the summary.
    `chartLegendInfo` - field info array of the chart legend.
    `chartLabelInfo` - field info array of the chart title and notes.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   int type,
                                   boolean isGroup,
                                   java.lang.String group1,
                                   java.lang.String group2,
                                   java.lang.String[] value)

  Deprecated. since version 8.0. Replaced by `insertChart(String, ChartInfo)`

  Inserts a chart object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new chart.
    `type` - type of the chart to be inserted
    `isGroup` - group level data or record level data.
    `group1` - mapping name of the first group.
    `group2` - mapping name of the second group. It can be null.
    `value` - mapping names of the summary.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   ChartLegendInfo chartLegendInfo,
                                   java.lang.String paperName)

  Inserts a chart object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `chartLegendInfo` - field info array of the chart legend.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   java.lang.String paperName,
                                   int type,
                                   boolean isGroup,
                                   java.lang.String group1,
                                   java.lang.String group2,
                                   java.lang.String[] value,
                                   ChartLegendInfo chartLegendInfo,
                                   ChartLabelInfo chartLabelInfo)

  Inserts a chart object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new chart.
    `paperName` - the instance name of ChartCoordinatepaper object
    `type` - type of the chart to be inserted
    `isGroup` - group level data or record level data.
    `group1` - mapping name of the first group.
    `group2` - mapping name of the second group. It can be null.
    `value` - mapping names of the summary.
    `chartLegendInfo` - field info array of the chart legend.
    `chartLabelInfo` - field info array of the chart title and notes.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   java.lang.String paperName,
                                   int type1,
                                   int type2,
                                   boolean isGroup,
                                   java.lang.String group1,
                                   java.lang.String group2,
                                   java.lang.String[] value,
                                   ChartLegendInfo chartLegendInfo,
                                   ChartLabelInfo chartLabelInfo)

  Inserts a combo chart object and its children into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new chart.
    `paperName` - the instance name of ChartCoordinatepaper object
    `type1` - type1 of the combo chart to be inserted
    `type2` - type2 of the combo chart to be inserted
    `isGroup` - group level data or record level data.
    `group1` - mapping name of the first group.
    `group2` - mapping name of the second group. It can be null.
    `value` - mapping names of the summary.
    `chartLegendInfo` - field info array of the chart legend.
    `chartLabelInfo` - field info array of the chart title and notes.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   int type,
                                   java.lang.String name,
                                   java.lang.String topSection,
                                   java.lang.String bottomSection)

  Inserts a shape object such as box, line, arc, or oval into the report.

  Parameters:
    `parent` - handle of the parent node.
    `name` - the instance name of the new shape.
    `type` - the type of the shape, such as box, line, arc, or oval.The useful constants:
    - `LINE`
    - `BOX`
    - `ROUNDBOX`
    - `OVAL`
    - `ARC`
    `topSection` - the handle of the top section the shape is attached to.
    `bottomSection` - the handle of the bottom section the shape is attached to.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   int type,
                                   java.lang.String name,
                                   GroupInfo groupInfo,
                                   SpecGroupInfo specGroupInfo)

  Inserts a group/sort into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `type` - object type to be inserted.
    `name` - instance name of the new object.
    `groupInfo` - The object to define the group
    `specGroupInfo` - The optional definition of the specified group
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### insert

    public java.lang.String insert(java.lang.String parent,
                                   java.lang.String name,
                                   GroupInfo groupInfo)

  Deprecated. since version 8.0. Replaced by `insertSectionGroup(group, groupInfo)`

  Inserts a group/sort into the parent node.

  Parameters:
    `parent` - handle of the parent node.
    `name` - instance name of the new object.
    `groupInfo` - the Class indicates the group definition.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.

### setPageWidth

    public void setPageWidth(double width)

  Sets the width of the page panel and also its sections.

  Parameters:
    `width` - the unit of the page width value can be set by `setUnit`.
  See Also:
    `setUnit(int)`

### setSortInfo

    public void setSortInfo(java.lang.String handle,
                            SortInfo[] sortInfo)

  Sets the sort information of the specified group

  Parameters:
    `handle` - Indicates the Group handle.
    `sortInfo` - Sort information array of this group.

### set

    public boolean set(java.lang.String handle,
                       java.lang.String name,
                       int value)

  Changes the property value of an object. The JReport property can by used as member parameter of an object. Set the property by the property name/value pairs.

  Overrides:
    `set` in class `API`
  Parameters:
    `handle` - handle of the target object.
    `name` - Indicates the property name.
    `value` - Sets the int type property value.
  Returns:
    `true` if the property value is changed successfully;`false` otherwise.
  See Also:
    `API.getPropType(String, String)`, `API.getInt(String, String)`

### set

    public boolean set(java.lang.String handle,
                       java.lang.String name,
                       float value)

  Changes the property value of an object. The JReport property can by used as member parameter of object. Set the property by the property name/value pairs.

  Overrides:
    `set` in class `API`
  Parameters:
    `handle` - handle of the target object.
    `name` - Indicates the property name.
    `value` - Sets the float type property value.
  Returns:
    `true` if the property value is changed successfully;`false` otherwise.
  See Also:
    `API.getPropType(String, String)`, `API.getFloat(String, String)`

### setReportSortInfo

    public void setReportSortInfo(java.lang.String handle,
                                  ReportSortInfo sortInfo)

  Sets the sort information of the whole report

  Parameters:
    `handle` - Indicates the report handle.
    `sortInfo` - report Sort information of this report

### getSortInfo

    public SortInfo[] getSortInfo(java.lang.String handle)

  Gets the sort information of the group or the report

  Parameters:
    `handle` - Indicates the report/group handle.
  Returns:
    SortInfo array

### getReportSortInfo

    public ReportSortInfo getReportSortInfo(java.lang.String handle)

  Gets the sort information of the report

  Parameters:
    `handle` - report handle
  Returns:
    ReportSortInfo that defines the sort options.

### getGroupInfo

    public GroupInfo[] getGroupInfo(java.lang.String handle)

  Gets the group information of the report.

  Parameters:
    `handle` - report handle
  Returns:
    groupInfo array that defines the group options

### delete

    public boolean delete(java.lang.String handle)

  Deletes an object from its parent node.

  Specified by:
    `delete` in class `API`
  Parameters:
    `handle` - handle of the object to be deleted.
  Returns:
    `true` if the object is removed from its parent node successfully; `false` Otherwise.
  See Also:
    `or getWarning() to get the reason if the object failed to be deleted.`

### canDeleted

    public boolean canDeleted(java.lang.String handle)

  Checks whether the instance can be deleted or not.

  Parameters:
    `handle` - indicates the object handle.
  Returns:
    `true` if the object can be deleted; otherwise `false`.

### getControlField

    public java.lang.String getControlField(java.lang.String handle,
                                            java.lang.String name)

  Gets the field that controls the property value at runtime. Some JReport object's property values can be defined as fields or formulas, so that their values can be fetched or calculated by the database fields.

  Parameters:
    `handle` - handle of the object whose property value to be checked.
    `name` - name of property.
  Returns:
    field mapping name if the property was defined as being controlled by other field; null otherwise.

### getControlFields

    public java.lang.String[] getControlFields(java.lang.String handle,
                                               java.lang.String name)

  Gets the fields that can be used to control an object's property values at runtime. The fields could be DBFields, formulas, or Summaries.

  Parameters:
    `handle` - handle of the object.
    `name` - name of the property.
  Returns:
    field mapping name array.

### setControlFields

    public boolean setControlFields(java.lang.String handle,
                                    java.lang.String prop,
                                    java.lang.String field)

  Sets the field to control the property value at runtime. The fields could be DBFields, formulas, or Summaries. The sql type and data range will be checked before the field is set to control a property.

  Parameters:
    `handle` - handle of the selected object.
    `prop` - property name.
    `field` - field mapping name.
  Returns:
    `true` if it is set successfully; `false` otherwise.

### getDBFields

    public java.lang.String[] getDBFields(java.lang.String handle)

  Gets the DBField mapping names from the query that is bound to the object

  Parameters:
    `handle` - handle of the object .
  Returns:
    mapping name arrray.

### getGroups

    public java.lang.String[] getGroups(java.lang.String handle)

  Gets the handles of the groups in a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
  Returns:
    the handles of the groups in the report.

### getGeometries

    public java.lang.String[] getGeometries(java.lang.String handle)

  Gets the handles of the geometry objects in a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
  Returns:
    the handles of the geometry objects.

### getGeometries

    public java.lang.String[] getGeometries(java.lang.String handle,
                                            boolean visible)

  Gets the handles of the geometry objects in a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's' object handle.
    `visible` - Gets the visible geometries or not.
  Returns:
    the handles of the geometry objects.

### getSections

    public java.lang.String[] getSections(java.lang.String handle)

  Gets the handles of the sections in a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
  Returns:
    the handles of the sections.

### getSections

    public java.lang.String[] getSections(java.lang.String handle,
                                          boolean visible)

  Gets the handles of the sections in a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
    `visible` - Gets the visible sections or not.
  Returns:
    the handles of the sections.

### getSections

    public java.lang.String[] getSections(java.lang.String handle,
                                          boolean visible,
                                          int type)

  Gets the handles of the sections in a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
    `visible` - get the visible sections or not.
    `type` - Indicates the section type. The useful constants:
    - `REPORTHEADER`
    - `REPORTFOOTER`
    - `PAGEHEADER`
    - `PAGEFOOTER`
    - `GROUPHEADER`
    - `GROUPFOOTER`
    - `DETAIL`
  Returns:
    the handles of sections.

### getQueryName

    public java.lang.String getQueryName(java.lang.String handle)

  Gets query name of a report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or its posterity's object handle.
  Returns:
    the mapping name of the query that the report is using.

### getFormulae

    public java.lang.String[] getFormulae(java.lang.String handle)

  Gets the formulae that can be used in the report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
  Returns:
    mapping name arrray of the formulae.

### getSummaries

    public java.lang.String[] getSummaries(java.lang.String handle)

  Gets the summaries that can be used in the report.

  Parameters:
    `handle` - the object handle to anchor the report. It could be a report handle or one of its children's object handle.
  Returns:
    mapping name array of the summaries.

### getParameter

    public java.lang.String[] getParameter()

  Gets all parameters in the default data source in the catalog.

  Returns:
    mapping name array of the parameters.

### getQueries

    public java.lang.String[] getQueries()

  Gets the queries in the default data source in the catalog.

  Returns:
    mapping name array of the queries.

### getQueries

    public java.lang.String[] getQueries(java.lang.String sourceName)

  Gets the queries in the specified data source in the catalog.

  Parameters:
    `sourceName` - Indicates the data source name in the catalog.
  Returns:
    mapping name array of the queries.

### getSQLs

    public java.lang.String[] getSQLs(java.lang.String sourceName)

  Gets Import SQLs in the specified data source in the catalog.

  Parameters:
    `sourceName` - Indicates the data source name in the catalog.
  Returns:
    mapping name array of SQLs.

### getSQLs

    public java.lang.String[] getSQLs()

  Gets Import SQLs in the default data source in the catalog.

  Returns:
    mapping name array of SQLs.

### getUDS

    public java.lang.String[] getUDS()

  Gets Import UDSs in the default data source in the catalog.

  Returns:
    mapping name array of UDSs.

### getUDS

    public java.lang.String[] getUDS(java.lang.String sourceName)

  Gets UDSs in the specified data source in the catalog.

  Parameters:
    `sourceName` - Indicates the data source name in the catalog.
  Returns:
    mapping name array of UDSs.

### getViews

    public java.lang.String[] getViews()

  Gets the database Views in the default data source in the catalog.

  Parameters:
    `sourceName` - Indicates the data source name in the catalog.
  Returns:
    mapping name array of the database Views.

### getProcedures

    public java.lang.String[] getProcedures(java.lang.String sourceName)

  Gets Stored Procedures in the specified data source in the catalog.

  Parameters:
    `sourceName` - Indicates the data source name in the catalog.
  Returns:
    mapping name array of Stored Procedures.

### getProcedures

    public java.lang.String[] getProcedures()

  Gets Stored Procedures in the default data source in the catalog.

  Parameters:
    `sourceName` - Indicates the data source name in the catalog.
  Returns:
    mapping name array of Stored Procedures.

### saveSelfReport

    public boolean saveSelfReport(java.lang.String path,
                                  java.lang.String name,
                                  java.lang.String newName)
                           throws java.io.IOException,
                                  jet.jetc.WriteFailureException,
                                  jet.universe.exception.FMLFileException,
                                  jet.jetc.ReadFailureException,
                                  jet.universe.exception.UniverseFileException

  Deprecated. since version 8.0,replaced by `saveSelfContainedReport(String, String, String )`.

  Saves the report as a self-contained report

  Parameters:
    `path` - the path that the report will be saved to
    `name` - the name of the catalog that the report will be saved to
    `newName` - new report name
  Throws:
    `java.io.IOException`
    `jet.jetc.WriteFailureException`
    `jet.universe.exception.FMLFileException`
    `jet.jetc.ReadFailureException`
    `jet.universe.exception.UniverseFileException`

### saveAs

    public java.lang.String saveAs(java.lang.String handle,
                                   java.lang.String newname)

  Saves a report as a new report file.

  Parameters:
    `handle` - the handle of the report.
    `newname` - the file name of the new report file.
  Returns:
    String value of the new report file name, including the suffix

### getObjectType

    public int getObjectType(java.lang.String handle)

  Gets the int type value of the object. Each of the objects have been defined an int constant type, such as `DBFIELD`.

  Parameters:
    `handle` - Indicates the object handle
  Returns:
    int value of the object type.
  See Also:
    `API.getHandles(String , int )`, `insert(String, int, String)`

### getFormats

    public java.lang.String[] getFormats(java.lang.String handle)

  Gets the default format list of the object. The formats match the SQL type of the object which is bound to the data.

  Parameters:
    `handle` - Indicates the object handle.
  Returns:
    String array of the formats.

### getObjectInfo

    public ObjectInfo getObjectInfo(java.lang.String handle)

  Gets the property information of the object. The ObjectInfo includes all properties and values of the object.

  Parameters:
    `handle` - indicates the handle of the entity
  Returns:
    ObjectInfo object which contains property names and values of the entity.

### getChangedByFields

    public java.lang.String[] getChangedByFields(java.lang.String handle,
                                                 java.lang.String propertyName)

  Gets the fields that can be used to control the object's property values at runtime. The fields could be DBFields, formulas, or Summary.

  Parameters:
    `handle` - handle of the object.
    `name` - name of property.
  Returns:
    field mapping name array.

### getMinSectionHeight

    public float getMinSectionHeight(java.lang.String handle)

  Gets the minimum height value of the section. This calculates the position and height of all the children of the section.

  Parameters:
    `handle` - handle of the section
  Returns:
    section's minimum height. The unit of the value is set by `API.setUnit(int)`, and the default is `#API.INCH`

### getParent

    public java.lang.String getParent(java.lang.String handle)

  Gets the container(parent) of the object.

  Overrides:
    `getParent` in class `API`
  Parameters:
    `handle` - Indicates the handle of the object.
  Returns:
    handle of the parent object.

### getChartLabel

    public ChartLabelInfo getChartLabel(java.lang.String handle)

  Gets the label information in the chart.

  Parameters:
    `handle` - Indicates the handle of chart platform.
  Returns:
    ChartLabelInfo that defines the chart label.

### createReportSet

    public java.lang.String createReportSet(java.lang.String name)
                                     throws DesignerErrorException

  Creates a new reportset with an instance name.

  Parameters:
    `name` - indicates the reportset's instance name.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### addReport

    public java.lang.String addReport(java.lang.String reportsetHandle,
                                      java.lang.String name)
                               throws DesignerErrorException

  Adds a report to the reportset.

  Parameters:
    `reportsetHandle` - Indicates the reportset's handle to which the report will be added.
    `name` - Indicates the report's instance name.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### addDataset

    public java.lang.String addDataset(java.lang.String reportsetHandle,
                                       java.lang.String datasourceName,
                                       java.lang.String queryName,
                                       java.lang.String name,
                                       java.lang.String BVName,
                                       int datasetType)
                                throws DesignerErrorException

  Creates a dataset in the reportset. A dataset is the set of data built from the result of a query, and can optionally have filters applied to it. A dataset contains not only DBFields, but also any formulas, summaries, and parameters that use the DBFields.A dataset has a name, which by default is the instance name of the resource on which it is created

  Parameters:
    `reportsetHandle` - Indicates the reportset's handle to which the dataset will be added.
    `datasourceName` - Indicates the data source's name the query belongs to.
    `queryName` - Indicates the dataset based query's mapping name. The dataset is created based on Query, UDS, Imported SQL, or Stored procedure. If it is `null`, the dataset is created by using a Business View.
    `name` - Indicates the dataset's instance name.
    `BVName` - Indicates the dataset is based on Business View's name when queryName is null.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setDataset

    public boolean setDataset(java.lang.String objHandle,
                              java.lang.String datasetHandle)
                       throws DesignerErrorException

  Applys a dataset to the report object. A dataset is the set of data built from the result of a query, and can optionally have filters applied to it. A dataset contains not only DBFields, but also any formulas, summaries, and parameters that use the DBFields. When you create a data component, you specify whether to create a new dataset or use an existing one. Having data components use an existing dataset whenever you can will possibly have a dramatic effect on the performance of your reports in the runtime environment. This is because each dataset is created by running a query against the database, which is the most expensive part in terms of execution time when running a report.

  Parameters:
    `objHandle` - Indicates the handler string of the report object.
    `datasetHandle` - Indicates the handler string of the existing dataset.
  Returns:
    `true` if the dataset is bound to the data component successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setDatasetBLFilter

    public boolean setDatasetBLFilter(java.lang.String datasetHandle,
                                      BLFilterInformation filterInfo)
                               throws DesignerErrorException

  Applys a JReport BusinessLogic filter to the dataset. A dataset is the set of data built from the result of a query, and can optionally have filters applied to it. A dataset contains not only DBFields, but also any formulas, summaries, and parameters that use the DBFields.

  Parameters:
    `datasetHandle` - Indicates the handler string of the existing dataset.
    `filterInfo` - The class defines the BusinessLogic Filter.
  Returns:
    `true` if the filter is bound to the dataset successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### getDatasetBLFilter

    public BLFilterInformation getDatasetBLFilter(java.lang.String datasetHandle)
                                           throws DesignerErrorException

  Gets a JReport businees logic filter from the specified dataset.

  Parameters:
    `datasetHandle` - Indicates the handler string of the existing dataset.
  Returns:
    JReport businees logic filter information
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteReport

    public boolean deleteReport(java.lang.String rptsetHandle,
                                java.lang.String name)
                         throws DesignerErrorException

  Deletes a report from the reportset. The report and its children will be removed from the specified reportset.

  Parameters:
    `name` - the instance name of the report to be deleted.
    `rptsetHandle` - the handle of the reportset
  Returns:
    `true` if the report is removed successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### getCatalogName

    public java.lang.String getCatalogName()

  Gets the loaded catalog's name.

  Returns:
    catalog name string.
  Since:
    JReport version 8.0.

### insertTable

    public java.lang.String insertTable(java.lang.String parent,
                                        TableTemplateInfo info)
                                 throws DesignerErrorException

  Inserts a new style (post V8) table into the report.

  Parameters:
    `parent` - the handle of the container object in which the table to be inserted.
    `info` - The class defines the new style (post V8) table's information.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### getTableWidth

    public double getTableWidth(java.lang.String parent,
                                TableTemplateInfo info)

  Gets the preferred table width according to the specified TableTemplateInfo.

  Parameters:
    `parent` - the handle of the container object that the table will be inserted into.
    `info` - new style (post V8) table information.
  Returns:
    table width value in defined unit.
  Since:
    JReport version 8.2
  See Also:
    `#API.setUnit(int)`

### getTableColumnHandle

    public java.lang.String getTableColumnHandle(java.lang.String tableHandle,
                                                 int index)

  Gets the specified table column's handle.

  Parameters:
    `tableHandle` - Indicates the handle of table.
    `index` - Indicates the index of the table columns; the first element is at index 0
  Returns:
    table column's handle
  Since:
    JReport version 10.0

### getTableColumnIndex

    public int getTableColumnIndex(java.lang.String columnHandle)

  Gets the table column's index.

  Parameters:
    `columnHandle` - Indicates the handle of the table column.
  Returns:
    index of the specified table column;the first element is at index 0.
  Since:
    JReport version 10.0

### insertTable

    public java.lang.String insertTable(java.lang.String parent,
                                        TableTemplateInfo info,
                                        boolean increasePanel)
                                 throws DesignerErrorException

  Inserts a new style (post V8) table into the report. The table is a data container, which can bind to a dataset itself, or inherit one from its parent container.

  Parameters:
    `parent` - the handle of the container object in which the table is to be inserted.
    `info` - The class defines the new style table's information. It may include the information of the data, group, or columns in the table.
    `increasePanel` - Indicates whether to increase the bounds when the table is out of the panel bounds. If it is `true`, the page width will be increased according to the table's width and position; `false`, the table's and its columns' width will be adjusted to fit the page.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8

### insertTableColumn

    public java.lang.String insertTableColumn(java.lang.String table,
                                              int index,
                                              int direction)
                                       throws DesignerErrorException

  Inserts a column into a new style table.

  Parameters:
    `table` - the handle of the table that the column to be inserted.
    `index` - Inserts a table column according to the specified column index.
    `direction` - Specifies the inserted column's location according to the index.
    - DIRECTION_BACKSIDE - The inserted column will be inserted at the specified index, the original column will move to the next, and so on.
    - DIRECTION_FORESIDE - The inserted column will be inserted at the next index, the original column will move to next, and so on.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertTableColumn

    public java.lang.String insertTableColumn(java.lang.String table,
                                              int index,
                                              int direction,
                                              java.lang.String fieldName,
                                              java.lang.String title,
                                              boolean increaseTable,
                                              boolean auotResetPage)
                                       throws DesignerErrorException

  Inserts a column with fields into a new style table

  Parameters:
    `table` - the handle of the table that the column to be inserted.
    `index` - Inserts the column at the specified index.
    `direction` - Specifies the inserted column's location according to the index.
    - DIRECTION_BACKSIDE - The inserted column will be inserted at the specified index, the original column will move to the next, and so on.
    - DIRECTION_FORESIDE - The inserted column will be inserted at the next index, the original column will move to the next, and so on.
    `fieldName` - the mapping name of the field which to be inserted into the table detail panel
    `title` - the title of the attached field that to be inserted into the table
    `increasetable` - Indicates whether to increase the width of the table when insertting the new column. If it is `true`, the table will be expanded according to the column width; `false`, all columns' width will be adjusted smaller to make room for the new one.
    `auotResetPage` - Indicates whether to resize the page when the table is out of the panel bound. This parameter works only when increasetable is set to `true`.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`

### deleteTableColumns

    public boolean deleteTableColumns(java.lang.String table,
                                      int[] index)
                               throws DesignerErrorException

  Deletes columns from a new style table.

  Parameters:
    `table` - the handle of the table.
    `index` - Indicates the index of the columns to be deleted.
  Returns:
    return `true` if the columns are deleted successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### moveTableColumns

    public boolean moveTableColumns(java.lang.String table,
                                    int[] index,
                                    int step,
                                    int direction)
                             throws DesignerErrorException

  Moves columns in a table

  Parameters:
    `table` - the handle of the table.
    `index` - Indicates the index of the columns to be moved.
    `step` - Indicates the step of the moving action.
    `direction` - the direction of the moving action. The useful constants for the direction:
    - DIRECTION_BACKSIDE
    - DIRECTION_FORESIDE
  Returns:
    return `true` if the columns are moved successfully, `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### mergeTableCells

    public boolean mergeTableCells(java.lang.String table,
                                   java.lang.String[] cellsid)
                            throws DesignerErrorException

  Merges table cells into one cell. All the contents of the cells are also merged.

  Parameters:
    `table` - the handle of the table.
    `cellsid` - Indicates the handle of the cells to be merged.
  Returns:
    return `true` if merged successfully, `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0
  See Also:
    `canMergeTableCell(String, String[])`

### canMergeTableCell

    public boolean canMergeTableCell(java.lang.String table,
                                     java.lang.String[] cellHandles)

  Checks whether the cells can be merged or not.

  Parameters:
    `table` - the handle of the table.
    `cellHandles` - indicates the handle of the cells to be merged.
  Returns:
    return `true` if the cells can be merged;`false` otherwise.
  Since:
    JReport version 8.0
  See Also:
    `mergeTableCells(String, String[])`

### canMergeTabularCell

    public boolean canMergeTabularCell(java.lang.String tabular,
                                       java.lang.String[] cellHandles)

  Checks whether the cells can be merged or not.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `cellHandles` - Indicates the handle of the cells to be merged.
  Returns:
    return `true` if the cells can be merged;`false` otherwise.
  Since:
    JReport version 8.0

### hideTableColumn

    public boolean hideTableColumn(java.lang.String table,
                                   int index)
                            throws DesignerErrorException

  Hides a table column. The column and its contents are invisible in the report result, but they can be referred.

  Parameters:
    `table` - Indicates the handle of the table.
    `index` - Indicates the Index of the column to be hidden.
  Returns:
    return `true` if the column is hidden successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### showTableColumn

    public boolean showTableColumn(java.lang.String table,
                                   int index)
                            throws DesignerErrorException

  Makes a hidden table column to be visible

  Parameters:
    `table` - the handle of the table.
    `index` - column index.
  Returns:
    return `true` if the column is made visible,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### resizeTable

    public boolean resizeTable(java.lang.String table,
                               int refPoint,
                               double xPercentage,
                               double yPercentage,
                               boolean increasePanel)
                        throws DesignerErrorException

  Resizes the table in the specified rate.

  Parameters:
    `table` - Indicates the handle of the table
    `refPoint` - Indicates the base point to resize the table.
    - LEFT_UPSIDE_POINT - the table's left top point.
    - LEFT_UNDERSIDE_POINT - the table's left under point.
    - RIGHT_UPSIDE_POINT - the table's right top point.
    - LEFT_UNDERSIDE_POINT - the table's right under point.
    `xPercentage` - percentage value of X axial to be resized. We assume 1.0 is 100%.
    `yPercentage` - percentage value of Y axial to be resized. We assume 1.0 is 100%.
    `increasePanel` - indicate whether to increase the panel when the table is out of the panel bound.
  Returns:
    return `true` if the table is resized successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setTableColumnWidth

    public boolean setTableColumnWidth(java.lang.String table,
                                       int index,
                                       double increment,
                                       boolean increaseTable,
                                       boolean increasePanel)
                                throws DesignerErrorException

  Resets the table column's width

  Parameters:
    `table` - Indicates the handle of the table.
    `index` - Indicates the column index.
    `increment` - Indicates the increment value of the column. The unit of the value can be set by `#API.setUnit(int)`, the default unit is inch.
    `increaseTable` - Indicates whether or not to resize the table when changing the column's width. If it is `true`, only change the specified column's width and increase the size of the table; `false`, the next column's width is changed to make room for the new width.
    `increasePanel` - Indicates whether or not to increase the panel when the table is out of the panel bound. Only if increaseTable is `true`, this parameter is used.
  Returns:
    return `true` if the table column is resized successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### pivotTable

    public boolean pivotTable(java.lang.String table,
                              int colIndex1,
                              int colIndex2)
                       throws DesignerErrorException

  Exchanges the specified table's columns.

  Parameters:
    `table` - Indicates the handle of the table.
    `colIndex1` - the index of the column to be exchanged.
    `colIndex2` - the index of the column to be exchanged.
  Returns:
    return `true` if the table columnsare exchanged successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertTableGroup

    public java.lang.String insertTableGroup(java.lang.String table,
                                             java.lang.String parentGroup,
                                             java.lang.String mapping,
                                             java.lang.String blName)
                                      throws DesignerErrorException

  Inserts a group into the table.

  Parameters:
    `table` - the handle of the table.
    `parentGroup` - the handle of the group in which the new group will be inserted. If it is null, the group will be inserted into the table directly.
    `mapping` - Indicates the groupby field mapping name.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### removeTableGroup

    public java.lang.String removeTableGroup(java.lang.String table,
                                             java.lang.String group)
                                      throws DesignerErrorException

  Removes the specified group from the table. Some of the table group's children, table group's header/footer and their children, are also removed; the others, such as the next group or the table details, need to be kept and will become the chilren of the previous group or the table.

  Parameters:
    `table` - Indicates the handle of the table.
    `group` - Indicates the handle of the removed group.
  Returns:
    the new table object's handle; `null` if the object failed to be removed. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertCrossTab

    public java.lang.String insertCrossTab(java.lang.String parent,
                                           CrossTabInfo info)
                                    throws DesignerErrorException

  Inserts a crosstab into the report.

  Parameters:
    `parent` - the handle of the object in which the crosstab to be inserted.
    `info` - the Class defines a crosstab's information, such as its data, properties, columns, rows, aggregations and also their properties.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertCrossTabColumns

    public java.lang.String insertCrossTabColumns(java.lang.String crossTab,
                                                  CTRowColFieldInfo[] infos,
                                                  int index)
                                           throws DesignerErrorException

  Inserts columns into a crosstab.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab in which the columns to be inserted.
    `infos` - The class defines the crosstab column's information, including the field mapping name and the properties.
    `index` - All columns of the crosstab can be defined as a set of groups in the crosstab. The index is defined as the index of all these groups, it starts with 0;
  Returns:
    the crosstab's handle; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertCrossTabRows

    public java.lang.String insertCrossTabRows(java.lang.String crossTab,
                                               CTRowColFieldInfo[] infos,
                                               int index)
                                        throws DesignerErrorException

  Inserts rows into a crosstab

  Parameters:
    `crossTab` - the handle of the crosstab.
    `infos` - The class defines the crosstab row's information, including the field mapping name and the properties.
    `index` - All rows of the crosstab can be defined as a set of groups in the crosstab. The index is defined as the index of all these groups, it starts with 0;
  Returns:
    the croostab's handle; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertCrossTabAggregations

    public java.lang.String insertCrossTabAggregations(java.lang.String crossTab,
                                                       CTAggFieldInfo[] infos,
                                                       int index)
                                                throws DesignerErrorException

  Inserts aggregations into a crosstab

  Parameters:
    `crossTab` - the handle of the crosstab.
    `infos` - The class defines the crosstab aggregation's information, including the field mapping name, the function and the properties.
    `index` - Inserts aggregations at the specified index. The index starts with 0.
  Returns:
    the crosstab's handle; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### moveCrossTabAggregations

    public java.lang.String moveCrossTabAggregations(java.lang.String crossTab,
                                                     int[] orignalIndex,
                                                     int desIndex)
                                              throws DesignerErrorException

  Adjusts crosstab aggregations' positions in the summary areas of a crosstab. Crosstab defines a set of aggregations depending on the rows and columns, and the indexes of the aggregations define the aggreations' positions in each summary area of the crosstab. Moving the specified aggregations to the target index, other aggregations in this set also respond the adjust of the position.

  Since crosstab creates duplicate aggregations in all crosstab summary areas, this method will change the positions of all corresponding aggregations.

  Parameters:
    `crossTab` - Indicates the handle of the crosscab.
    `orignalIndex` - indicates the aggregation indexes to be moved. The index starts with 0.
    `desIndex` - indicates the target index to which the specified aggregations to be moved. The index starts with 0.
  Returns:
    the handle of crosstab if it moves the aggregations successfully; `null` otherwise. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### moveCrossTabRows

    public java.lang.String moveCrossTabRows(java.lang.String crossTab,
                                             int[] orignalIndex,
                                             int desIndex)
                                      throws DesignerErrorException

  Adjusts a crosstab's row order. The rows of a crosstab are defined as a nested group in Y direction layout of a crosstab. This method changes the order of the specified rows, and it also changes the order of the groups; the order of other rows in this crosstab is also changed correspondingly.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `orignalIndex` - indicates the index of the rows to be moved. The index starts with 0.
    `desIndex` - Indicates the target index to which the specified the rows to be moved. The index starts with 0.
  Returns:
    the handle of crosstab if it moves the rows successfully; `null` otherwise. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### moveCrossTabColumns

    public java.lang.String moveCrossTabColumns(java.lang.String crossTab,
                                                int[] orignalIndex,
                                                int desIndex)
                                         throws DesignerErrorException

  Adjusts a crosstab's column order. The columns of a crosstab are defined as a nested group in X direction layout of the crosstab. This method changes the order of the specified columns, and it also changes the order of the groups; the order of other columns in this crosstab is also changed correspondingly.

  Parameters:
    `crossTab` - Indicates the handle of crosstab.
    `orignalIndex` - indicates the index of the columns to be moved. The index starts with 0.
    `desIndex` - Indicates the target index to which the specified the columns to be moved. The index starts with 0.
  Returns:
    the handle of crosstab if it moves the columns successfully; `null` otherwise. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteCrossTabColumns

    public boolean deleteCrossTabColumns(java.lang.String crossTab,
                                         int[] index)
                                  throws DesignerErrorException

  Deletes crosstab columns. The columns of a crosstab are defined as a nested group in X direction layout of the crosstab. This method deletes the specified columns, the group nodes, and also the aggregations depending on such columns; the order of other columns in this crosstab is also changed correspondingly.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the indexes of the columns to be removed. The index starts with 0.
  Returns:
    `true` if the columns are deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteCrossTabRows

    public boolean deleteCrossTabRows(java.lang.String crossTab,
                                      int[] index)
                               throws DesignerErrorException

  Deletes rows from a crosstab. The rows of a crosstab are defined as a nested group in Y direction layout of the crosstab. This method deletes the specified rows, the group nodes, and also the aggregations depending on such rows; the order of other rows in this crosstab is also changed correspondingly.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the indexed of the rows to be removed. The index starts with 0.
  Returns:
    `true` if the rows are deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteCrossTabAggregations

    public boolean deleteCrossTabAggregations(java.lang.String crossTab,
                                              int[] index)
                                       throws DesignerErrorException

  Deletes aggregations from a crosstab.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the indexes of the aggregations to be removed. The index starts of 0.
  Returns:
    `true` if the aggregations are deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setCTColHeaderHeight

    public boolean setCTColHeaderHeight(java.lang.String crossTab,
                                        int index,
                                        double height)
                                 throws DesignerErrorException

  Sets the specified column header's cell height of a crosstab. This method also correspondingly changes the height of the aggregation's title cell which depends on the column, and the height of the previous(outer) columns' aggregation's title.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the index of the column to be set.
    `height` - Indicates the height value of the specified column header's cell. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if successful; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setCTRowHeaderWidth

    public boolean setCTRowHeaderWidth(java.lang.String crossTab,
                                       int index,
                                       double width)
                                throws DesignerErrorException

  Sets the specified row header's cell width of crosstab. This method also correspondingly changes the width of the aggregation's title cell which depends on the row, and the height of the previous(outer) rows' aggregation's title.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the index of the row to be set.
    `width` - Indicates the width value of the specified row header's cell. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if successful; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setCTAggTitleHeight

    public boolean setCTAggTitleHeight(java.lang.String crossTab,
                                       int index,
                                       double height)
                                throws DesignerErrorException

  sets the height of a crosstab aggregation's title

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the index of the title to be set
  Returns:
    `true` if successful; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setCTAggTitleWidth

    public boolean setCTAggTitleWidth(java.lang.String crossTab,
                                      int index,
                                      double width)
                               throws DesignerErrorException

  sets the width of a crosstab aggregation's title

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `index` - indicates the index of the title to be set
  Returns:
    `true` if successful; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setCTAggFieldHeight

    public boolean setCTAggFieldHeight(java.lang.String crossTab,
                                       int yDepth,
                                       int index,
                                       double height)
                                throws DesignerErrorException

  Sets the specified aggregation's height in a crosstab. Crosstab defines a set of aggregation areas depending on the rows and columns, and the indexes of the aggregations defines the aggreations' positions in each summary area of the crosstab. Setting the height of the specified aggregation, other aggregations, which depend on the same crosstab row(yDepth), in the crosstab also respond the setting of the height. This also resizes the crosstab.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `yDepth` - indicates the index of the row on which the aggregation depends. The yDepth starts with 0. The level 0 is the area of the column subtoal or the grand toatl; the level 1 responds to the first element of the rows.
    `index` - indicates the aggregation index in a crosstab's summary cell. If the aggregations in one summary cell are wrapped into several lines, specifies the horizontal line to be set. The index starts with 0.
    `height` - Indicates the aggregation field's height value. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if the height is set successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setCTAggFieldWidth

    public boolean setCTAggFieldWidth(java.lang.String crossTab,
                                      int xDepth,
                                      int index,
                                      double width)
                               throws DesignerErrorException

  Sets the specified aggregation's width in a crosstab. Crosstab defines a set of aggregation areas depending on the rows and columns, and the indexes of the aggregations define the aggreations' positions in each summary area of crosstab. Setting the width of the specified aggregation, other aggregations, which depend on the same crosstab column(xDepth), in the crosstab also respond the setting of the width. This also resizes the crosstab.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
    `xDepth` - indicates the index of the column on which the aggregation depends. The xDepth starts with 0. The level 0 is the area of the row subtoal or the grand toatl; the level 1 responds to the first element of the columns.
    `index` - indicates the aggregation index in a crosstab's summary cell. If the aggregations in one summary cell are wrapped into several lines, specifies the vetical line to be set. The index starts with 0.
    `height` - Indicates the aggregation field's height value. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if the width is set successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### pivotCrossTab

    public boolean pivotCrossTab(java.lang.String crossTab)
                          throws DesignerErrorException

  Pivots the crosstab. Exchanges the columns and rows in the crosstab, and also all aggregations.

  Parameters:
    `crossTab` - Indicates the handle of the crosstab.
  Returns:
    `true` if the crosstab is pivoted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertTabular

    public java.lang.String insertTabular(java.lang.String parent,
                                          java.lang.String tabularName,
                                          int colVol,
                                          int rowVol)
                                   throws DesignerErrorException

  Inserts a new tabular object into a report. A tabular is a component designed to lay out other components. Unlike a table component, that is used to display a dataset, a tabular is a set of cells that can each display a dataset in a component.

  Creates a tabular in row*column cells.

  Parameters:
    `parent` - the handle of the object in which the tabular to be inserted.
    `tabularName` - Indicates the tabular object's instance name, it can be null.
    `colVol` - Indicates the number of columns in the tabular.
    `rowVol` - Indicates the number of rows in the tabular.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### resizeTabular

    public boolean resizeTabular(java.lang.String tabular,
                                 int refPoint,
                                 double xPercentage,
                                 double yPercentage,
                                 boolean increasePanel)
                          throws DesignerErrorException

  Resizes the Tabular in the specified rate. Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `table` - Indicates the handle of the tabular
    `refPoint` - Indicates the base point to resize the tabular.
    - LEFT_UPSIDE_POINT - the table's left top point.
    - LEFT_UNDERSIDE_POINT - the table's left under point.
    - RIGHT_UPSIDE_POINT - the table's right top point.
    - LEFT_UNDERSIDE_POINT - the table's right under point.
    `xPercentage` - percentage value of X axial tabular to be resized. We assume 1.0 is 100%.
    `yPercentage` - percentage value of Y axial tabular to be resized. We assume 1.0 is 100%.
    `increasePanel` - indicates whether to increase the panel when the tabular is out of the panel bound.
  Returns:
    return `true` if the tabular is resized successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### appendTabularColumn

    public boolean appendTabularColumn(java.lang.String tabular)
                                throws DesignerErrorException

  Adds a tabular column after the last column of the tabular. The tabular's total width does not change, in other words, the width of all the columns and the cells change correspondingly.

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
  Returns:
    return `true` if a tabular column is added successfully,`false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### appendTabularRow

    public boolean appendTabularRow(java.lang.String tabular)
                             throws DesignerErrorException

  Adds a tabular row after the last row of the tabular. The tabular's total height does not change, in other words, the height of all the rows and the cells change correspondingly.

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
  Returns:
    return `true` if a tabular row is aded successfully, `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### changeTabularWidth

    public boolean changeTabularWidth(java.lang.String tabular,
                                      double dispersion)
                               throws DesignerErrorException

  Modifies a tabular object's width. The tabular's total width changes, so that in other words, the width of all the columns and the cells change correspondingly.

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `dispersion` - Sets the changed width's dispersion value. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if the tabular's width is changed successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### changeTabularHeight

    public boolean changeTabularHeight(java.lang.String tabular,
                                       double dispersion)
                                throws DesignerErrorException

  Modifies a tabular object's height. The tabular's total height changes, so that in other words, the height of all the rows and the cells change correspondingly.

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `dispersion` - Sets the changed tabular height's dispersion value. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if the tabular's height is changed successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### changeTabularCellWidth

    public boolean changeTabularCellWidth(java.lang.String tabular,
                                          java.lang.String cellHandle,
                                          double dispersion)
                                   throws DesignerErrorException

  Modifies a tabular cell object's width. The width of all the cells which are in same column with the specified cell will change according to the specified cell. If the specified cell is in the rightest column, the tabular's total width will expand/shrink; otherwise, the tabular's total width does not change, so that the width of the next column, in other words, the width of the cells in the right column changes correspondingly.

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - the handle of the tabular.
    `cellHandle` - indicates the cell handle to be changed.
    `dispersion` - Sets the changed cell's width dispersion value. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if the cell's width is changed successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### changeTabularCellHeight

    public boolean changeTabularCellHeight(java.lang.String tabular,
                                           java.lang.String cellHandle,
                                           double dispersion)
                                    throws DesignerErrorException

  Modifies a tabular cell object's height. The height of all the cells which are in same row with the specified cell will change according to the specified cell. The tabular's total height will expand/shrink;

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - the handle of the tabular.
    `cellHandle` - indicates the cell handle to be changed.
    `dispersion` - Sets the changed cell's height dispersion value. The unit of the value is set by `API.setUnit(int)`, and the default is `API.INCH`
  Returns:
    `true` if the cell's height is changed successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteTabularColumn

    public boolean deleteTabularColumn(java.lang.String tabular,
                                       java.lang.String cellHandle)

  Deletes a tabular column from a tabular. All the cells and their components which are in the same column with the specified cell will be deleted. The tabular's total width does not change, so that in other words, the width of the remained columns and all the cells enlarges correspondingly.

  Resizing the tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `cellHandle` - Indicates the cell handle to locate the column. Any of the cells can specify a corresponding column.
  Returns:
    `true` if the column is deleted successfully; `false` otherwise.
  Since:
    JReport version 8.0

### deleteTabularRow

    public boolean deleteTabularRow(java.lang.String tabular,
                                    java.lang.String cellHandle)
                             throws DesignerErrorException

  Deletes a tabular row from a tabular. All the cells and their components which are in the same row with the specified cell will be deleted. The tabular's total height does not change, so that the height of the remained rows, in other words, the height of all cells, enlarges correspondingly.

  Resizing tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `cellHandle` - Indicates the cell handle to locate the row. Any of the cells can specify a corresponding row.
  Returns:
    `true` if the row is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### splitTabularCell

    public boolean splitTabularCell(java.lang.String tabular,
                                    java.lang.String cellHandle,
                                    int rowVol,
                                    int clmVol)
                             throws DesignerErrorException

  Splits a tabular cell into a set of cells. The cell will be split into m*n cells. The components in the cell are keep in the first cell.

  Resizing tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `cellHandle` - Indicates the handle of the cell to be split.
    `rowVol` - Sets the row number of the new cell set.
    `clmVol` - Sets the column number of the new cell set.
  Returns:
    `true` if the cell is split successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### mergeTabularCells

    public java.lang.String mergeTabularCells(java.lang.String tabular,
                                              java.lang.String[] cellsid)
                                       throws DesignerErrorException

  Merges several tabular cells into one cell. These cells should form a rectangle in geography. All the components in these cells should also be merged into the new cell.

  Resizing tabular and its cells does not resize the objects inside the tabular.

  Parameters:
    `tabular` - Indicates the handle of the tabular.
    `cellsid` - indicates the handle of the cell to be merged.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0
  See Also:
    `canMergeTabularCell(String, String[])`

### getTabularColumnCells

    public java.lang.String[] getTabularColumnCells(java.lang.String tabular,
                                                    int index)
                                             throws DesignerErrorException

  Gets the handles of the cells in a specified tabular column.

  Parameters:
    `tabular` - the handle of the tabular object
    `index` - indicates the tabular column's index. The index starts with 0.
  Returns:
    the handles of the cells in the specified tabular column.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### getTabularRowCells

    public java.lang.String[] getTabularRowCells(java.lang.String tabular,
                                                 int index)
                                          throws DesignerErrorException

  Gets the handles of the cells in a specified tabular row

  Parameters:
    `tabular` - the handle of the tabular object
    `index` - indicates the tabular row's index. The index starts with 0.
  Returns:
    the handles of the cells in the specified tabular row.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### getTabularCell

    public java.lang.String getTabularCell(java.lang.String tabular,
                                           int rowIndex,
                                           int colIndex)
                                    throws DesignerErrorException

  Gets the handle of the cell in the specified tabular row or column.

  Parameters:
    `tabular` - the handle of the tabular object
    `rowIndex` - indicates the tabular row's number. The index starts with 0.
    `columnIndex` - indicates the tabular column's number. The index starts with 0.
  Returns:
    the handle of the cell in the specified tabular row or column.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertPage

    public java.lang.String insertPage(java.lang.String reportHandle)
                                throws DesignerErrorException

  Inserts a page panel object into a report.

  Parameters:
    `reportHandle` - the handle of the report.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deletePage

    public boolean deletePage(java.lang.String pageHandle)
                       throws DesignerErrorException

  Deletes a page panel object from a report.

  Parameters:
    `pageHandle` - the handle of the page object to be removed.
  Returns:
    `true` if the page is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertPageBreak

    public java.lang.String insertPageBreak(java.lang.String parent,
                                            java.lang.String referredHandle,
                                            boolean isinsertedBefore)
                                     throws DesignerErrorException

  Inserts a page break object into a report.

  Parameters:
    `parent` - handle of the parent container.
    `referredHandle` - indicates the referred object to insert the page breaker into.
    `isinsertedBefore` - indicates to insert the page breaker before the referred object or not.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertPageStartEnd

    public java.lang.String[] insertPageStartEnd(java.lang.String pageHandle,
                                                 java.lang.String parent,
                                                 int startIndex,
                                                 int endIndex)
                                          throws DesignerErrorException

  Inserts a page control object into a report

  Parameters:
    `pageHandle` - the handle of the report page panel.
    `parent` - handle of the parent container.
    `startIndex` - indicates the object index to start a page
    `endIndex` - indicates the object index to end a page
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deletePageController

    public boolean deletePageController(java.lang.String controllerHandle)
                                 throws DesignerErrorException

  Deletes a page controller object from a report

  Parameters:
    `controllerHandle` - the handle of the page controller object
  Returns:
    `true` if the page controller is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertBandedObject

    public java.lang.String insertBandedObject(java.lang.String parent,
                                               boolean withHeader,
                                               boolean withFooter,
                                               boolean withDetail)
                                        throws DesignerErrorException

  Inserts a Banded Object into a report. A banded object is a kind of component that can present grouped data and detailed data. A banded object is composed of several banded panels with which you can easily organize data fields and other elements.

  In JReport, banded objects are data containers, which means that a banded object displays the results of a query and you can apply some filters to narrow down the records displayed in it.

  Parameters:
    `parent` - Indicates the handle of the parent node.
    `withHeader` - indicate whether to insert Banded Object with banded header object or not.
    `withFooter` - indicates whether to insert Banded Object with footer object or not.
    `withDetail` - indicate whether to insert Banded Object with detail object or not.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertSubReport

    public java.lang.String insertSubReport(java.lang.String parent,
                                            SubReportInfo info)
                                     throws DesignerErrorException

  Inserts a Subreport into a report.

  Parameters:
    `parent` - handle of the parent object in which the subreport to be inserted.
    `info` - The class defines the information of the subreport.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`

### deleteBandedObject

    public boolean deleteBandedObject(java.lang.String bandedObject)
                               throws DesignerErrorException

  Deletes a Banded Object from a report

  Parameters:
    `bandedObject` - the handle of Banded Object
  Returns:
    `true` if the object is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertSectionGroup

    public java.lang.String insertSectionGroup(java.lang.String parent,
                                               GroupInfo groupInfo)
                                        throws DesignerErrorException

  Inserts a group object into a report. Some children of the parent node will become the children of the group after the group is inserted.

  Parameters:
    `parent` - handle of the parent node.
    `groupInfo` - the group properties' information.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteGroup

    public boolean deleteGroup(java.lang.String groupHandle,
                               boolean removeAllChildren)
                        throws DesignerErrorException

  Deletes a group object from a report. Some children which are attached to the group, such as group header/footer, will be deleted; but others, such as the nested groups or detail sections will become the children of the deleted group's parent.

  Parameters:
    `groupHandle` - Indicates the handle of the group object to be deleted.
    `removeAllChildren` - indicates whether to remove the nested groups of the specified group. Note: if it is `true`, the report structure may be destroyed. The recommended parameter value is `false`.
  Returns:
    `true` if the object is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### getIndex

    public int getIndex(java.lang.String objHandle)

  Gets the child index in its parent container. This index is not the position index in the layout mode.

  Parameters:
    `objHandle` - Indicates the handle of the object.
  Returns:
    index number of its parent's children list.
  Since:
    JReport version 8.0

### insertDetailPanel

    public java.lang.String insertDetailPanel(java.lang.String parent,
                                              java.lang.String referredHandle,
                                              boolean isinsertedBefore)
                                       throws DesignerErrorException

  Inserts a detail section object into a report.

  Parameters:
    `parent` - handle of the parent container.
    `referredHandle` - indicates the referred section in the parent container, and it should also present a detail panel.
    `isinsertedBefore` - indicates whether to insert the section before the referred section or not
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteDetailPanel

    public boolean deleteDetailPanel(java.lang.String detailSection)
                              throws DesignerErrorException

  Deletes a detail section from a report.

  Parameters:
    `detailSection` - Indicates the handle of the detail section to be deleted.
  Returns:
    `true` if the object is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertSectionHeaderPanel

    public java.lang.String insertSectionHeaderPanel(java.lang.String parent,
                                                     java.lang.String referredHandle,
                                                     boolean isinsertedBefore)
                                              throws DesignerErrorException

  Inserts a banded object header section object into a report

  Parameters:
    `parent` - handle of the parent container.
    `referredHandle` - indicates the referred section in the parent container, and it should present a header section panel also.
    `isinsertedBefore` - indicates to insert the section before the referred section or not
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteSectionHeaderPanel

    public boolean deleteSectionHeaderPanel(java.lang.String headerSection)
                                     throws DesignerErrorException

  Deletes a header section from a report.

  Parameters:
    `headerSection` - the handle of the header section
  Returns:
    `true` if the object is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertSectionFooterPanel

    public java.lang.String insertSectionFooterPanel(java.lang.String parent,
                                                     java.lang.String referredHandle,
                                                     boolean isinsertedBefore)
                                              throws DesignerErrorException

  Inserts a banded object section footer into a report

  Parameters:
    `parent` - handle of the parent container.
    `referredHandle` - indicates the referred section in the parent container, and it should present a footer section panel
    `isinsertedBefore` - indicates to insert the section before the referred section or not
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertSectionPanel

    public java.lang.String insertSectionPanel(java.lang.String parent,
                                               java.lang.String referredHandle,
                                               int sectionType,
                                               boolean isinsertedBefore)
                                        throws DesignerErrorException

  Inserts a banded object section into a report

  Parameters:
    `parent` - handle of the parent container.
    `referredHandle` - indicates the referred section in the parent container, and it should present a footer section panel
    `sectionType` - indicates the type of the section to be inserted into the banded object. The useful constants:
    - `PAGEHEADER`
    - `PAGEFOOTER`
    - `GROUPHEADER`
    - `GROUPFOOTER`
    - `BANDEDOBJECT_PAGEHEADER`
    - `BANDEDOBJECT_PAGEFOOTER`
    - `BANDEDOBJECT_HEADER`
    - `BANDEDOBJECT_FOOTER`
    `isinsertedBefore` - indicates whether to insert the section before the referred section or not
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### deleteSectionFooterPanel

    public boolean deleteSectionFooterPanel(java.lang.String footerSection)
                                     throws DesignerErrorException

  Deletes a footer section from a report

  Parameters:
    `footerSection` - Indicates the handle of the footer section.
  Returns:
    `true` if the object is deleted successfully; `false` otherwise.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertField

    public java.lang.String insertField(java.lang.String parent,
                                        java.lang.String mappingName,
                                        java.lang.String blName,
                                        int fieldType,
                                        int renderType)
                                 throws DesignerErrorException

  Inserts a field object into a report. The field can be a database field, label field, formula, paramemter, summary, media field, or special field.

  Parameters:
    `parent` - Indicates the handle of the parent node.
    `mappingName` - the mapping name of the inserted field. For label and special field, it can be null. If the `mappingName` and `blName` both are set, the `blName` has the highest priority to be selected.
    `blName` - the businessLogic field name of the inserted field. For label and special field, it can be null. If the `mappingName` and `blName` both are set, the `blName` has the highest priority to be selected.
    `fieldType` - Indicates the int value of the field type. The useful constants:
    - `DBFIELD`
    - `FORMULA`
    - `SUMMARY`
    - `MEDIAFIELD`
    - `PARAMETER`
    - `LABEL`
    - `USERNAME`
    - `PRINTDATE`
    - `PRINTTIME`
    - `FETCHDATE`
    - `FETCHTIME`
    - `MODIFIEDDATE`
    - `MODIFIEDTIME`
    - `RECORDNUMBER`
    - `GROUPNAME`
    - `GROUPNUMBER`
    - `GROUPNUMBERS`
    - `PAGENUMBER`
    - `PAGENUMBERS`
    - `SQLSTATMENT`
    `renderType` - the int value of the field render type. The useful constants:
    - `RENDER_RANK`
    - `RENDER_BARCODE`
    - `RENDER_IMAGE`
    - `RENDER_TEXTFIELD`
    - `RENDER_IMAGE`
    - `RENDER_TEXT`
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### insertShape

    public java.lang.String insertShape(java.lang.String parent,
                                        Shape shape)
                                 throws DesignerErrorException

  Inserts a geometry object into a report. The geometry object can be presented as Line, Box, RoundBox, Oval, or Arc.

  Parameters:
    `parent` - handle of the parent node.
    `shape` - the definition of the inserted object.
  Returns:
    the new object's handle if successful; `null` if the object failed to be inserted. Use `API.getError()` to get the reason for the failure.
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setReporthome

    public void setReporthome(java.lang.String reporthome)

  Sets the reporthome of the application. The reporthome is the JReport installroot and work directory. JReport will load resources and information from it, such as user license, font, and style.

  Parameters:
    `reporthome` - the install root path of JReport product.
  Since:
    JReport version 8.0

### getReporthome

    public java.lang.String getReporthome()

  Gets the install root of the application,

  Returns:
    the install root path of JReport product.
  Since:
    JReport version 8.0

### bindDataSet

    public boolean bindDataSet(java.lang.String handle,
                               java.lang.String datasetName)

  Binds a dataset to a data container object. A dataset is the set of data built from the result of a query, and can optionally have filters applied to it. A dataset contains not only DBFields, but also any formulas, summaries, and parameters that use the DBFields.

  A dataset has a name, which by default is the name of the resource on which it is created

  When you bind a data component to a dataset whenever you can use an existing dataset. This may possibly have a dramatic effect on the performance of your reports in the runtime environment. This is because each dataset is created by running a query against the database, which is the most expensive part in terms of execution time when running a report.

  Parameters:
    `handle` - handle of the report object node that the datset is bound to.
    `datasetName` - the mapping name of the dataset name.
  Returns:
    `true` if the dataset is bound to the data container successfully; `false` otherwise.
  Since:
    JReport version 8.0

### insertChart

    public java.lang.String insertChart(java.lang.String parent,
                                        ChartInfo info)
                                 throws DesignerErrorException

  Inserts a chart into a report.

  Parameters:
    `parent` - the handle of the object in which the chart to be inserted.
    `info` - The class defines the information of the chart.
  Returns:
    the new object's handle; `null`if the object fails to be inserted and use `API.getError()` to get the reason.``
  Throws:
    `DesignerErrorException`
  Since:
    JReport version 8.0

### setStyle

    public boolean setStyle(java.lang.String reportHandle,
                            java.lang.String viewName,
                            java.lang.String styleName)

  Sets css or a style to the report. You can apply a style in the process of creating a report or at any time when designing a report. During report design, if you have applied more than one style to a component, the last style always covers the previous style.

  Parameters:
    `reportHandle` - the handle of the report.
    `viewName` - the name of the view of the report. It is not supported yet, so it can be null.
    `styleName` - Indicates the style filename. JReport will find it in `%installroot%/style` or `%reporthome%/style`.
  Returns:
    `true` if the report's style is set successfully; `false` otherwise.
  Since:
    JReport version 8.0
  See Also:
    `setReporthome(String)`

### setStyle

    public boolean setStyle(java.lang.String reportHandle,
                            java.lang.String[] objectHandles,
                            java.lang.String styleName,
                            boolean isURL)

  Sets css or a style to the report objects. You can apply a style in the process of creating a report or at any time when designing a report. During report design, if you have applied more than one style to a component, the last style always covers the previous style.

  Parameters:
    `reportHandle` - the handle of the report.
    `objectHandles` - the handle list of the objects that the style to be applied to.
    `styleName` - Indicates the style filename. JReport will find it in `%installroot%/style` or `%reporthome%/style`.
  Returns:
    `true` if the object's style is set successfully; `false` otherwise.
  Since:
    JReport version 8.0
  See Also:
    `setReporthome(String)`

### setDefaultFormat

    public boolean setDefaultFormat(java.lang.String handle)

  Sets a default object format for an object. Specifies the display format of the text in the report result. It varies with data type and can be manually defined.

  Parameters:
    `handle` - the handle of the object.
  Returns:
    `true` if the object is formatted successfully; `false` otherwise.
  Since:
    JReport version 8.2

### saveSelfContainedReport

    public boolean saveSelfContainedReport(java.lang.String rptHandle,
                                           java.lang.String path,
                                           java.lang.String filename)
                                    throws java.io.IOException,
                                           jet.jetc.WriteFailureException,
                                           jet.universe.exception.FMLFileException,
                                           jet.jetc.ReadFailureException,
                                           jet.universe.exception.UniverseFileException

  Saves the report as a self-contained report. A self-contained report includes both the report template and the catalog.

  Parameters:
    `rptHandle` - Indicates the handle of the reportset to be saved as a self-contained report.
    `path` - the path the report will be saved to.
    `filename` - the file name the report will be saved as.
  Throws:
    `java.io.IOException`
    `jet.jetc.WriteFailureException`
    `jet.universe.exception.FMLFileException`
    `jet.jetc.ReadFailureException`
    `jet.universe.exception.UniverseFileException`

### addDisplayName

    public void addDisplayName(java.lang.String report,
                               DisplayNameInfo displayNameInfo)

  Adds a Display Name into a report. In JReport Viewer, you can drill around report data, sort report data on certain fields, search a report for some text, and filter the report data using filter conditions. When you perform these operations, you will be working with field mapping names. However, with just the field mapping names, you may find it inconvenient for end users, especially when the field mapping name is obscure. To help you, JReport provides a DisplayName customizing function for you to define the column names as required, and also to specify the actions which the display names will take part in.

  Parameters:
    `report` - Indicates the handle of the report.
    `displayNameInfo` - The class defines the information of DisplayName object.

### addDisplayName

    public boolean addDisplayName(java.lang.String report,
                                  java.lang.String datasetHandle,
                                  DisplayNameInfo displayNameInfo)

  Adds a DisplayName to a report. In JReport Viewer, you can drill around report data, sort report data on certain fields, search a report for some text, and filter the report data using filter conditions. When you perform these operations, you will be working with field mapping names. However, with just the field mapping names, you may find it inconvenient for end users, especially when the field mapping name is obscure. To help you, JReport provides a display name customizing function for you to define the column names as required, and also to specify the actions which the display names will take part in.

  Parameters:
    `report` - Indicates the handle of the report.
    `displayNameInfo` - The class defines the information of DisplayName object.
  Returns:
    `true` If DisplayName object is added successfully; `false` otherwise.

### getFormulas

    public java.lang.String[] getFormulas(java.lang.String report)

  Gets all formula names used in a report.

  Parameters:
    `report` - Indicates the handle of the report.
  Returns:
    all formula names in the current report.

### getGroupNames

    public java.util.Vector getGroupNames(java.lang.String report)

  Gets all groupby fields' mapping names of the groups in a report.

  Parameters:
    `report` - Indicates the handle of the report.
  Returns:
    all groupby field mapping names in the report.

### getAllResourceNames

    public java.lang.String[] getAllResourceNames(java.lang.String report)

  Gets all resource names used in report.

  Parameters:
    `report` - Indicates the handle of report.
  Returns:
    a string array, contains all resource names in current report.

### removeDisplayName

    public boolean removeDisplayName(java.lang.String report,
                                     DisplayNameInfo displayNameInfo)

  Removes a DisplayName object from a report.

  Parameters:
    `report` - Indicates the handle of the report.
    `displayNameInfo` - The class defines the information of DisplayName object.
  Returns:
    `true` if the DisplayName object is deleted successfully;`false` otherwise.
  See Also:
    `addDisplayName(String, String, DisplayNameInfo)`

### getAllDisplayNames

    public java.util.Vector getAllDisplayNames(java.lang.String report)

  Gets all DisplayName objects in a report.

  Parameters:
    `report` - Indicates the handle of the report.
  Returns:
    a vector, contains all display names' information.

### getDisplayName

    public DisplayNameInfo getDisplayName(java.lang.String report,
                                          java.lang.String resourceName)

  Gets the definition of DisplayName by field mapping name.

  Parameters:
    `report` - Indicates the handle of the report.
    `resourceName` - Indicates the field mapping name.
  Returns:
    the Definition of DisplayName if its resource name matches the specified mapping Name; `null` otherwise.

### updateDisplayName

    public void updateDisplayName(java.lang.String report,
                                  DisplayNameInfo displayNameInfo)

  Updates the properties of an existing DisplayName in a report.

  Parameters:
    `report` - Indicates the handle of the report.
    `displayNameInfo` - The class defines the information of DisplayName object.

### changeZOrder

    public boolean changeZOrder(java.lang.String objectHandle,
                                int zorderType)

  Sets z-order of cascading objects.

  Parameters:
    `objectHandle` - handle of the object whose z-order to be set.
    `zorderType` - the direction of the object to be moved. The useful constants:
    - `ZORDER_TOP`
    - `ZORDER_BOTTOM`
    - `ZORDER_FORWARD`
    - `ZORDER_BACKWARD`
  Returns:
    `true` if the object's z-order is changed successfully; `false` otherwise.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD